//
// Class CGenOptWin for 'General Options Window'
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.awt.*;
import java.awt.event.*;

public class CGenOptWin extends Dialog implements ActionListener
{
  //Variables
  CGlobal g=null;

  Dimension size;

  Checkbox comp1;
  Checkbox comp2;
  TextField tf3;

  Button comp3a;
  Button comp3b;
  Button comp3c;

  String str3a="Default";
  String str3b="OK";
  String str3c="Cancel";

  String opt1="";
  String opt2="";
  String opt3="";

  // *******************************************************************
  public CGenOptWin(Frame dw, CGlobal glob)
  {
    super(dw, "General Options", true);
 
    g=glob;

    int gap=10;

    //First panel for border
    Panel p=new Panel();
    FlowLayout lt=new FlowLayout(FlowLayout.LEFT);
    lt.setHgap(gap);
    lt.setVgap(gap);

    setLayout(lt);

    add(p);

    BorderLayout lt0=new BorderLayout();
    lt0.setHgap(gap);
    lt0.setVgap(gap);

    GridLayout lt1=new GridLayout(3,2);
    lt1.setHgap(gap);
    lt1.setVgap(gap);

    FlowLayout lt2=new FlowLayout(FlowLayout.CENTER);

    CFramedArea p1=new CFramedArea();
    p1.setLayout(lt1);

    Panel p2=new Panel();
    p2.setLayout(lt2);

    comp1=new Checkbox("");
    comp2=new Checkbox("");
    tf3=new TextField("", 40);
    p1.add(new Label("Save position and size of the main window on exit:")); 
    p1.add(comp1); 
    p1.add(new Label("Show \"About Program\" during loading:"));
    p1.add(comp2);
    p1.add(new Label("Local Project Directory:"));
    p1.add(tf3);
                
    comp3a=new Button(str3a);
    comp3a.addActionListener(this);
    comp3b=new Button(str3b);
    comp3b.addActionListener(this);
    comp3c=new Button(str3c);
    comp3c.addActionListener(this);

    p2.add(comp3a);
    p2.add(comp3b);
    p2.add(comp3c);

    p.setLayout(lt0);
    p.add("Center", p1);
    p.add("South", p2);		

    //Positioning
    Point pt=dw.getLocationOnScreen();

    setLocation(pt.x+40, pt.y+40);

    //Packing elements in window
    pack();

    size=getSize();
		
    //Initializing parameters
    opt1=g.cfg.GetParamStr(g.cfgSPS);
    opt2=g.cfg.GetParamStr(g.cfgSWA);
    opt3=g.cfg.GetParamStr(g.cfgPath);

    //Updating parameters
    my_update();

    enableEvents(AWTEvent.WINDOW_EVENT_MASK|
                 AWTEvent.COMPONENT_EVENT_MASK);

    show();
  }

  // *******************************************************************
  public void actionPerformed(ActionEvent e) 
  {
    String x;

    String command = e.getActionCommand();
    if (command.equals(str3a)) 
    {	        
      //Default Parameters !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      opt1="1";
      opt2="1";
      opt3="";

      my_update();
    } 
    else if (command.equals(str3b))
    {           
      if (comp1.getState()==false) x="0"; else x="1";
      g.cfg.SetParamStr(g.cfgSPS, x);

      if (comp2.getState()==false) x="0"; else x="1";
      g.cfg.SetParamStr(g.cfgSWA, x);

      g.cfg.SetParamStr(g.cfgPath, tf3.getText());

      g.cfg.Save();
	
      dispose();
    } 
    else if (command.equals(str3c)) 
    {
      dispose();
    } 
  }

  // *******************************************************************
  protected void processEvent(AWTEvent e)
  {
    if (getSize()!=size)
    {
      setSize(size);
    }

    if (e.getID() == Event.WINDOW_DESTROY)
    {
      dispose();
    }
  }

  // *******************************************************************
  private void my_update()
  {
    boolean x;

    if (opt1.equals("0")) x=false; else x=true;
    comp1.setState(x);

    if (opt2.equals("0")) x=false; else x=true;
    comp2.setState(x);

    tf3.setText(opt3);
  }
}
