//
// Process Messages
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.net.*;
import java.io.*;

public class ProcessMessages
{
  public ProcessMessages(Socket sockfd, CGlobal g)
  {
    int misc;

    //Initialize instructions (need to do it in each process!)
    CSIParse sip = new CSIParse();

    if (sip.Init(30, 0)!=0)
    //            |  |
    //            |  |------- Case Sensitive (0) or not (1)
    //            |
    //            |---------- Max Number of Options
    {
      System.out.println("\nError: Can't initialize object CSIParse!");
      return;
    }

    misc=0;
  
    char ch=0;                            
    misc =sip.Add("initiate",              1, ' ', "");   //Param  0
    misc+=sip.Add("terminate",             0, ch,  "");   //Param  1
    misc+=sip.Add("directory",             1, '=', "");   //Param  2
    misc+=sip.Add("file_diag_out",         1, '=', "");   //Param  3
    misc+=sip.Add("file_project",          1, '=', "");   //Param  4
    misc+=sip.Add("file_out",              1, '=', "");   //Param  5
    misc+=sip.Add("filename_add",          1, '=', "");   //Param  6
    misc+=sip.Add("parse",                 0, ch,  "");   //Param  7
    misc+=sip.Add("tree",                  0, ch,  "");   //Param  8
    misc+=sip.Add("profile",               1, '=', "");   //Param  9
    misc+=sip.Add("compilation_mode",      1, '=', "");   //Param 10
    misc+=sip.Add("no_checking",           1, '=', "");   //Param 11
    misc+=sip.Add("optimizations",         1, '=', "");   //Param 12
    misc+=sip.Add("compile",               0, ch,  "");   //Param 13
    misc+=sip.Add("file_out_time",         1, '=', "");   //Param 14
    misc+=sip.Add("file_out_comp",         1, '=', "");   //Param 15
    misc+=sip.Add("file_out_prof",         1, '=', "");   //Param 16
    misc+=sip.Add("prof_type",             1, '=', "");   //Param 17
    misc+=sip.Add("runmode",               1, '=', "");   //Param 18
    misc+=sip.Add("run",                   0, ch,  "");   //Param 19
    misc+=sip.Add("remove_obj",            0, ch,  "");   //Param 20
    misc+=sip.Add("tool",                  1, '=', "");   //Param 21
    misc+=sip.Add("run_tool",              0, ch,  "");   //Param 22
    misc+=sip.Add("feedback",              1, '=', "");   //Param 23
    misc+=sip.Add("param",                 1, '=', "");   //Param 24
    misc+=sip.Add("param1",                1, '=', "");   //Param 25
    misc+=sip.Add("create_dir_copy_files", 0, ch,  "");   //Param 26

    if (misc!=0)
    {
      System.out.println("\nError: Internal, while initializing CSIParse!");
      return;
    }

    //Process Instructions
    new ProcessInstructions(sockfd, g, sip);
  }      
}
