//
// Misc functions
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

#include "misc.h"

//Sockets
#ifdef W32
#  include <winsock2.h>
#  include <wsipx.h>
#else
#  include <sys/socket.h>
#  include <sys/types.h>
#endif

#include <string.h>

#include <iostream.h>

int SendMes(int sockfd, char* str, int param, int maxlen)
{
  char* buf=new char[maxlen];
  strcpy(buf, str);
  strcat(buf,"\r\n");

  int misc=send(sockfd, buf, strlen(buf), param);
  
  if (misc<0)
  {
    cerr << "Error: Can't send data to client!\n";
  }

  delete buf;

  return misc;
}

int RecvMes(int sockfd, char* str, int param, int maxlen)
{
  char* buf=new char[maxlen];

  int i=0;
  int nread=0;

  for (i=0; i<maxlen; i++)
  {
    nread=recv(sockfd, &buf[i], 1, 0);

    if (nread<0) break;

    if ((nread==0) || (buf[i]=='\n'))
    {
      buf[i+1]=0;
      strcpy(str, buf);
      break;      
    }
  }

  if (nread>0) nread=1;

  delete buf;

  return nread;
}

void GetPath(char* str1, char* str)
{
  int l=strlen(str);
  int j=0;

#ifdef W32
  char str_sep='\\';
#else
  char str_sep='/';
#endif

  strcpy(str1, str);

  if (strcmp(str, "")==0)
  {
    strcpy(str1, "");
  }
  else
  {
    for (j=l-1; j>=0; j--)
    {
      if (str1[j]==str_sep) break;
      str1[j]=0;
    }
  }
}
