//
// Process Instructions
//
// Copyright (C) 2000-2004 by Grigori G.Fursin
//
// http://homepages.inf.ed.ac.uk/gfursin
//
// ICSA, School of Informatics,
// University of Edinburgh, UK
//

//Import libraries...
import java.net.*;
import java.io.*;
import java.util.*;

public class ProcessInstructions
{
  String f_tmp      = "_eos_s_tmp";
  String f_tmp1     = "_eos_s_tmp1";
  String f_tmp2     = "_eos_s_tmp2";
  String f_tmp3     = "_eos_s_tmp3";
  String f_tmp_prj  = "_eos_s_prj_tmp";
  String f_tmp_prj2 = "_eos_s_prj_tmp2"; //also the same string and name
                                         //is used in some other classes!
                                         //check before changing!
  String f_prs      = "_parsed";

  String fs01="_eos_s_tree";

  public ProcessInstructions(Socket sockfd, CGlobal g, CSIParse s)
  {
    String str="";
    String buf="";
    int buf1;
    char buf2;
    String xerr="";
    boolean enter=false;
    int misc;
    
    PrintWriter out;
    BufferedReader in;

    //Parameters
    int initiate=0;
    String str_dir="";
    String str_f_prj="";
    String str_f_diag_out="";
    String str_f_tree_in="";
    String str_strategy="";
    String str_step="";
    String str_precision="";
    String str_optimization="";
    String str_no_transf="";
    String str_record_tr="";
    String str_f_info="";
    String str_apnd="";
    boolean apnd=false;
    String str_optimization1="";
    String str_file_time_out="";
    String str_pt1="";
    String str_pt2="";
    String str_pt3="";
    String str_pu1="";
    String str_pu2="";
    String str_pu3="";
    String str_pp1="";
    String str_pp2="";
    String str_pp3="";
    String str_iio="";
    String str_sfb="";
    String str_f_prj_out="";
    String str_f_info_out="";
    String str_grid="";
    String str_rnd="";
    String str_fti="";
    String str_apo="";
    String str_cdes="";
    String str_dir_ic="";
    String str_noe="";
    
    try 
    {
      out=new PrintWriter(sockfd.getOutputStream(), true);
      in =new BufferedReader(new InputStreamReader(sockfd.getInputStream()));

      for (;;)
      {
        buf="";
        int p=0;
        int esc=0;
        
        while ((buf1=in.read())!='\r')
        {
          if (buf1==-1)
          {
//            System.out.println("Session complete!");
            return;
          }
          
          buf2=(char) buf1;
          
          //Checking for characters
          if ((buf1>31) && (buf1<127))
          {
            if (esc==0)
            {
              p++;
              buf+=buf2;

              //send echo  
              out.print(buf2);
              out.flush();
            }
            else if (esc==1) esc=2;
            else esc=0;
          }
          else if (buf1==27)
          {
            //Escape
            if (esc==0) esc=1;
            else if (esc==1) esc=0;
          }
          else if (buf1=='\n')
          {
            //Ignore character
            if (esc==1) esc=2;
            else esc=0;
          }
          else if (buf1=='\b')
          {
            //Backspace
            if (esc==0)
            {
              if (p>0) 
              {
                p--;
                buf=buf.substring(0,p);

                //send echo  
                out.print("\b \b");
                out.flush();        
              }
            }
            else if (esc==1) esc=2;
            else esc=0;
          }
        }

        out.print('\r');
        out.print('\n');
        out.flush();
        
        //process instruction ********************************************************
        misc=s.Parse(buf);

        if (misc<0)
        {
          switch (misc)
          {
            case -1:
            {
              xerr="Warning: Line is empty!";
              break;
            }
            case -2:
            {
              xerr="Error: Unknown instruction!";
              break;
            }
            case -3:
            {
              xerr="Error: This instruction needs parameter!";
              break;
            }
            case -4:
            {
              xerr="Error: This instruction doesn't need parameters!";
              break;
            } 
            case -5:
            {
              xerr="Error: Wrong separator!";
              break;
            }
            default:
            {
              xerr="Error: Can't parse!";
              break;
            }
          }

          out.println(xerr);
          out.flush();
        }
        else
        {
          //Process instructions
          if (misc==g.instrInitiate)
          {
            if (s.GetParamStrLwr(g.instrInitiate).equals("search"))
            {
              initiate=1;

              str_dir="";
              str_f_prj="";
              str_f_diag_out="";
              str_f_tree_in="";
              str_strategy="";
              str_step="";
              str_precision="";
              str_optimization="";
              str_no_transf="";
              str_record_tr="";
              str_f_info="";
              str_apnd="";
              apnd=false;
              str_optimization1="";
              str_file_time_out="";
              str_pt1="";
              str_pt2="";
              str_pt3="";
              str_pu1="";
              str_pu2="";
              str_pu3="";
              str_pp1="";
              str_pp2="";
              str_pp3="";
              str_iio="";
              str_sfb="";
              str_f_prj_out="";
              str_f_info_out="";
              str_grid="";
              str_rnd="";
              str_fti="";
              str_apo="";
              str_cdes="";
              str_dir_ic="";
              str_noe="";

              out.println("Ok");
              out.flush();
            }
            else
            {
              out.println("Error: Unknown parameter for 'initiate'!");
              out.flush();
            }
          }
          else if (misc==g.instrTerminate)
          {
            out.println("Ok [Session finished]");
            out.flush();
            return; //Finish
          }
          else if (misc==g.instrDirectory)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_dir=s.GetParamStr(g.instrDirectory);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrFileProject)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_f_prj=s.GetParamStr(g.instrFileProject);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrFileDiagOut)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_f_diag_out=s.GetParamStr(g.instrFileDiagOut);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrCDES)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_cdes=s.GetParamStr(g.instrCDES);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrDOAppend)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_apnd=s.GetParamStr(g.instrDOAppend);
              if (str_apnd.equals("1")) apnd=true; else apnd=false;

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrFileProjectOut)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_f_prj_out=s.GetParamStr(g.instrFileProjectOut);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrFileInfoOut)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_f_info_out=s.GetParamStr(g.instrFileInfoOut);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrDirIC)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_dir_ic=s.GetParamStr(g.instrDirIC);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrNOE)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_noe=s.GetParamStr(g.instrNOE);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrFileInfo)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_f_info=s.GetParamStr(g.instrFileInfo);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrFileTreeIn)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_f_tree_in=s.GetParamStr(g.instrFileTreeIn);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrStrategy)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_strategy=s.GetParamStr(g.instrStrategy);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrStep)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_step=s.GetParamStr(g.instrStep);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrPrecision)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_precision=s.GetParamStr(g.instrPrecision);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrOptimization)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_optimization=s.GetParamStr(g.instrOptimization);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrOptimization1)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_optimization1=s.GetParamStr(g.instrOptimization1);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrFTI)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_fti=s.GetParamStr(g.instrFTI);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrAPO)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_apo=s.GetParamStr(g.instrAPO);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrFileTimeOut)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_file_time_out=s.GetParamStr(g.instrFileTimeOut);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrNoTransf)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_no_transf=s.GetParamStr(g.instrNoTransf);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrRecordTr)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_record_tr=s.GetParamStr(g.instrRecordTr);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrIIO)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_iio=s.GetParamStr(g.instrIIO);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrSFB)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_sfb=s.GetParamStr(g.instrSFB);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrGo)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              if (str_dir.equals(""))
              {
                out.println("Error: Parameter 'directory' is empty!");
                out.flush();
              }
              else if (str_f_prj.equals(""))
              {
                out.println("Error: Parameter 'file_project' is empty!");
                out.flush();
              }
              else if (str_f_diag_out.equals(""))
              {
                out.println("Error: Parameter 'file_diag_out' is empty!");
                out.flush();
              }
              else
              {
                if (str_strategy.equals("")) str_strategy="0";
                if (str_optimization.equals("")) str_optimization="0";
                if (str_no_transf.equals("")) str_no_transf="0";

                String str_dir1=CMisc.ProcessDir(g.cfg.GetParamStr(g.cfgPathLocal), 
                                                 g.cfg.GetParamStr(g.cfgSeparator));
 
                String str_dir2=str_dir1+CMisc.ProcessDir(str_dir, g.cfg.GetParamStr(g.cfgSeparator));

                BufferedWriter fout=null;

                boolean created=true;

                try
                {
                  fout=new BufferedWriter(new FileWriter(str_dir2+str_f_diag_out, apnd));
                }
                catch (IOException e1)
                {
                  out.println("Error: Can't open diagnostic file for writing!");
                  out.flush();
                  created=false;
                }

                if (created)
                {
                  Go(out, g, fout, str_dir2, str_f_prj,
                                   str_f_tree_in, str_strategy,
                                   str_step, str_precision,
                                   str_optimization, str_no_transf,
                                   str_record_tr);
                  try
                  {
                    fout.close();
                  }
                  catch (Exception e5)
                  {}
                }
              }
            }
          }
          else if (misc==g.instrGo1)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              if (str_dir.equals(""))
              {
                out.println("Error: Parameter 'directory' is empty!");
                out.flush();
              }
              else if (str_f_prj.equals(""))
              {
                out.println("Error: Parameter 'file_project' is empty!");
                out.flush();
              }
              else if (str_f_diag_out.equals(""))
              {
                out.println("Error: Parameter 'file_diag_out' is empty!");
                out.flush();
              }
              else
              {
                String str_dir1=CMisc.ProcessDir(g.cfg.GetParamStr(g.cfgPathLocal), 
                                                 g.cfg.GetParamStr(g.cfgSeparator));
 
                String str_dir2=str_dir1+CMisc.ProcessDir(str_dir, g.cfg.GetParamStr(g.cfgSeparator));

                BufferedWriter fout=null;

                boolean created=true;

                try
                {
                  fout=new BufferedWriter(new FileWriter(str_dir2+str_f_diag_out, apnd));
                }
                catch (IOException e1)
                {
                  out.println("Error: Can't open diagnostic file for writing!");
                  out.flush();
                  created=false;
                }

                if (created)
                {
                  Go1(out, g, fout, str_dir2, str_f_prj, str_f_info_out);

                  try
                  {
                    fout.close();
                  }
                  catch (Exception e5)
                  {}
                }
              }
            }
          }
          else if (misc==g.instrGo2)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              if (str_dir.equals(""))
              {
                out.println("Error: Parameter 'directory' is empty!");
                out.flush();
              }
              else if (str_f_prj.equals(""))
              {
                out.println("Error: Parameter 'file_project' is empty!");
                out.flush();
              }
              else if (str_f_diag_out.equals(""))
              {
                out.println("Error: Parameter 'file_diag_out' is empty!");
                out.flush();
              }
              else if (str_optimization.equals(""))
              {
                out.println("Error: Parameter 'optmization' is empty!");
                out.flush();
              }
              else if (str_optimization1.equals(""))
              {
                out.println("Error: Parameter 'optmization1' is empty!");
                out.flush();
              }
              else if (str_f_tree_in.equals(""))
              {
                out.println("Error: Parameter 'file_tree_in' is empty!");
                out.flush();
              }
              else if (str_file_time_out.equals(""))
              {
                out.println("Error: Parameter 'file_time_out' is empty!");
                out.flush();
              }
              else
              {
                String str_dir1=CMisc.ProcessDir(g.cfg.GetParamStr(g.cfgPathLocal), 
                                                 g.cfg.GetParamStr(g.cfgSeparator));
 
                String str_dir2=str_dir1+CMisc.ProcessDir(str_dir, g.cfg.GetParamStr(g.cfgSeparator));

                BufferedWriter fout=null;

                boolean created=true;

                try
                {
                  fout=new BufferedWriter(new FileWriter(str_dir2+str_f_diag_out, apnd));
                }
                catch (IOException e1)
                {
                  out.println("Error: Can't open diagnostic file for writing!");
                  out.flush();
                  created=false;
                }

                if (created)
                {
                  Go2(out, g, fout, str_dir2, str_f_prj, 
                      str_optimization, str_optimization1,
                      str_f_tree_in, str_file_time_out, false);

                  try
                  {
                    fout.close();
                  }
                  catch (Exception e5)
                  {}
                }
              }
            }
          }
          else if (misc==g.instrGo2a)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              if (str_dir.equals(""))
              {
                out.println("Error: Parameter 'directory' is empty!");
                out.flush();
              }
              else if (str_f_prj.equals(""))
              {
                out.println("Error: Parameter 'file_project' is empty!");
                out.flush();
              }
              else if (str_f_diag_out.equals(""))
              {
                out.println("Error: Parameter 'file_diag_out' is empty!");
                out.flush();
              }
              else if (str_optimization.equals(""))
              {
                out.println("Error: Parameter 'optmization' is empty!");
                out.flush();
              }
              else if (str_f_tree_in.equals(""))
              {
                out.println("Error: Parameter 'file_tree_in' is empty!");
                out.flush();
              }
              else if (str_file_time_out.equals(""))
              {
                out.println("Error: Parameter 'file_time_out' is empty!");
                out.flush();
              }
              else
              {
                String str_dir1=CMisc.ProcessDir(g.cfg.GetParamStr(g.cfgPathLocal), 
                                                 g.cfg.GetParamStr(g.cfgSeparator));
 
                String str_dir2=str_dir1+CMisc.ProcessDir(str_dir, g.cfg.GetParamStr(g.cfgSeparator));

                BufferedWriter fout=null;

                boolean created=true;

                try
                {
                  fout=new BufferedWriter(new FileWriter(str_dir2+str_f_diag_out, apnd));
                }
                catch (IOException e1)
                {
                  out.println("Error: Can't open diagnostic file for writing!");
                  out.flush();
                  created=false;
                }

                if (created)
                {
                  Go2(out, g, fout, str_dir2, str_f_prj, 
                      str_optimization, str_optimization1,
                      str_f_tree_in, str_file_time_out, true);

                  try
                  {
                    fout.close();
                  }
                  catch (Exception e5)
                  {}
                }
              }
            }
          }
          else if (misc==g.instrGo3)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              if (str_dir.equals(""))
              {
                out.println("Error: Parameter 'directory' is empty!");
                out.flush();
              }
              else if (str_f_prj.equals(""))
              {
                out.println("Error: Parameter 'file_project' is empty!");
                out.flush();
              }
              else if (str_f_diag_out.equals(""))
              {
                out.println("Error: Parameter 'file_diag_out' is empty!");
                out.flush();
              }
              else if (str_optimization.equals(""))
              {
                out.println("Error: Parameter 'optmization' is empty!");
                out.flush();
              }
              else if (str_optimization1.equals(""))
              {
                out.println("Error: Parameter 'optmization1' is empty!");
                out.flush();
              }
              else if (str_f_tree_in.equals(""))
              {
                out.println("Error: Parameter 'file_tree_in' is empty!");
                out.flush();
              }
              else if (str_file_time_out.equals(""))
              {
                out.println("Error: Parameter 'file_time_out' is empty!");
                out.flush();
              }
              else if (str_strategy.equals(""))
              {
                out.println("Error: Parameter 'strategy' is empty!");
                out.flush();
              }
              else if (str_fti.equals(""))
              {
                out.println("Error: Parameter 'file_time_in' is empty!");
                out.flush();
              }
              else
              {
                String str_dir1=CMisc.ProcessDir(g.cfg.GetParamStr(g.cfgPathLocal), 
                                                 g.cfg.GetParamStr(g.cfgSeparator));
 
                String str_dir2=str_dir1+CMisc.ProcessDir(str_dir, g.cfg.GetParamStr(g.cfgSeparator));

                BufferedWriter fout=null;

                boolean created=true;

                try
                {
                  fout=new BufferedWriter(new FileWriter(str_dir2+str_f_diag_out, apnd));
                }
                catch (IOException e1)
                {
                  out.println("Error: Can't open diagnostic file for writing!");
                  out.flush();
                  created=false;
                }

                if (created)
                {
                  Go3(out, g, fout, str_dir2, str_f_prj,
                                    str_f_tree_in, str_strategy,
                                    str_precision,
                                    str_optimization, str_optimization1,
                                    str_record_tr, str_file_time_out,
                                    str_step,
                                    str_pt1, str_pt2, str_pt3,
                                    str_pu1, str_pu2, str_pu3,
                                    str_pp1, str_pp2, str_pp3,
                                    str_grid, str_rnd,
                                    str_iio, str_sfb,
                                    str_f_prj_out, str_f_info_out,
                                    str_fti, str_apo, str_cdes, false,
                                    str_dir_ic, str_noe);
                  try
                  {
                    fout.close();
                  }
                  catch (Exception e5)
                  {}
                }
              }
            }
          }
          else if (misc==g.instrGo3a)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              if (str_dir.equals(""))
              {
                out.println("Error: Parameter 'directory' is empty!");
                out.flush();
              }
              else if (str_f_prj.equals(""))
              {
                out.println("Error: Parameter 'file_project' is empty!");
                out.flush();
              }
              else if (str_f_diag_out.equals(""))
              {
                out.println("Error: Parameter 'file_diag_out' is empty!");
                out.flush();
              }
              else if (str_optimization.equals(""))
              {
                out.println("Error: Parameter 'optmization' is empty!");
                out.flush();
              }
              else if (str_f_tree_in.equals(""))
              {
                out.println("Error: Parameter 'file_tree_in' is empty!");
                out.flush();
              }
              else if (str_file_time_out.equals(""))
              {
                out.println("Error: Parameter 'file_time_out' is empty!");
                out.flush();
              }
              else if (str_strategy.equals(""))
              {
                out.println("Error: Parameter 'strategy' is empty!");
                out.flush();
              }
              else if (str_fti.equals(""))
              {
                out.println("Error: Parameter 'file_time_in' is empty!");
                out.flush();
              }
              else
              {
                String str_dir1=CMisc.ProcessDir(g.cfg.GetParamStr(g.cfgPathLocal), 
                                                 g.cfg.GetParamStr(g.cfgSeparator));
 
                String str_dir2=str_dir1+CMisc.ProcessDir(str_dir, g.cfg.GetParamStr(g.cfgSeparator));

                BufferedWriter fout=null;

                boolean created=true;

                try
                {
                  fout=new BufferedWriter(new FileWriter(str_dir2+str_f_diag_out, apnd));
                }
                catch (IOException e1)
                {
                  out.println("Error: Can't open diagnostic file for writing!");
                  out.flush();
                  created=false;
                }

                if (created)
                {
                  Go3(out, g, fout, str_dir2, str_f_prj,
                                    str_f_tree_in, str_strategy,
                                    str_precision,
                                    str_optimization, str_optimization1,
                                    str_record_tr, str_file_time_out,
                                    str_step,
                                    str_pt1, str_pt2, str_pt3,
                                    str_pu1, str_pu2, str_pu3,
                                    str_pp1, str_pp2, str_pp3,
                                    str_grid, str_rnd,
                                    str_iio, str_sfb,
                                    str_f_prj_out, str_f_info_out,
                                    str_fti, str_apo, str_cdes, true,
                                    str_dir_ic, str_noe);

                  try
                  {
                    fout.close();
                  }
                  catch (Exception e5)
                  {}
                }
              }
            }
          }
          else if (misc==g.instrGo4)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              if (str_dir.equals(""))
              {
                out.println("Error: Parameter 'directory' is empty!");
                out.flush();
              }
              else if (str_f_diag_out.equals(""))
              {
                out.println("Error: Parameter 'file_diag_out' is empty!");
                out.flush();
              }
              else if (str_file_time_out.equals(""))
              {
                out.println("Error: Parameter 'file_time_out' is empty!");
                out.flush();
              }
              else
              {
                String str_dir1=CMisc.ProcessDir(g.cfg.GetParamStr(g.cfgPathLocal), 
                                                 g.cfg.GetParamStr(g.cfgSeparator));
 
                String str_dir2=str_dir1+CMisc.ProcessDir(str_dir, g.cfg.GetParamStr(g.cfgSeparator));

                Go4(out, g, str_dir2, str_f_diag_out, str_file_time_out);
              }
            }
          }
          else if (misc==g.instrPT1)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_pt1=s.GetParamStr(g.instrPT1);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrPT2)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_pt2=s.GetParamStr(g.instrPT2);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrPT3)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_pt3=s.GetParamStr(g.instrPT3);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrPU1)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_pu1=s.GetParamStr(g.instrPU1);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrPU2)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_pu2=s.GetParamStr(g.instrPU2);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrPU3)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_pu3=s.GetParamStr(g.instrPU3);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrPP1)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_pp1=s.GetParamStr(g.instrPP1);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrPP2)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_pp2=s.GetParamStr(g.instrPP2);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrPP3)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_pp3=s.GetParamStr(g.instrPP3);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrGo5)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              if (str_dir.equals(""))
              {
                out.println("Error: Parameter 'directory' is empty!");
                out.flush();
              }
              else if (str_f_diag_out.equals(""))
              {
                out.println("Error: Parameter 'file_diag_out' is empty!");
                out.flush();
              }
              else if (str_f_tree_in.equals(""))
              {
                out.println("Error: Parameter 'file_tree_in' is empty!");
                out.flush();
              }
              else if (str_strategy.equals(""))
              {
                out.println("Error: Parameter 'strategy' is empty!");
                out.flush();
              }
              else
              {
                String str_dir1=CMisc.ProcessDir(g.cfg.GetParamStr(g.cfgPathLocal), 
                                                 g.cfg.GetParamStr(g.cfgSeparator));
 
                String str_dir2=str_dir1+CMisc.ProcessDir(str_dir, g.cfg.GetParamStr(g.cfgSeparator));

                BufferedWriter fout=null;

                boolean created=true;

                try
                {
                  fout=new BufferedWriter(new FileWriter(str_dir2+str_f_diag_out, apnd));
                }
                catch (IOException e1)
                {
                  out.println("Error: Can't open diagnostic file for writing!");
                  out.flush();
                  created=false;
                }

                if (created)
                {
                  Go5(out, g, fout, str_dir2,
                                    str_f_tree_in, str_strategy,
                                    str_pt1, str_pt2, str_pt3,
                                    str_pu1, str_pu2, str_pu3,
                                    str_pp1, str_pp2, str_pp3,
                                    str_grid, str_rnd);
                  try
                  {
                    fout.close();
                  }
                  catch (Exception e5)
                  {}
                }
              }
            }
          }
          else if (misc==g.instrGo6)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              if (str_f_prj.equals(""))
              {
                out.println("Error: Parameter 'file_project' is empty!");
                out.flush();
              }
              else if (str_dir.equals(""))
              {
                out.println("Error: Parameter 'directory' is empty!");
                out.flush();
              }
              else if (str_f_diag_out.equals(""))
              {
                out.println("Error: Parameter 'file_diag_out' is empty!");
                out.flush();
              }
              else if (str_f_tree_in.equals(""))
              {
                out.println("Error: Parameter 'file_tree_in' is empty!");
                out.flush();
              }
              else
              {
                String str_dir1=CMisc.ProcessDir(g.cfg.GetParamStr(g.cfgPathLocal), 
                                                 g.cfg.GetParamStr(g.cfgSeparator));
 
                String str_dir2=str_dir1+CMisc.ProcessDir(str_dir, g.cfg.GetParamStr(g.cfgSeparator));

                BufferedWriter fout=null;

                boolean created=true;

                try
                {
                  fout=new BufferedWriter(new FileWriter(str_dir2+str_f_diag_out, apnd));
                }
                catch (IOException e1)
                {
                  out.println("Error: Can't open diagnostic file for writing!");
                  out.flush();
                  created=false;
                }

                if (created)
                {
                  Go6(out, g, fout, str_dir2, str_f_prj, str_f_tree_in);

                  try
                  {
                    fout.close();
                  }
                  catch (Exception e5)
                  {}
                }
              }
            }
          }
          else if (misc==g.instrGRID)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_grid=s.GetParamStr(g.instrGRID);

              out.println("Ok");
              out.flush();
            }
          }
          else if (misc==g.instrRND)
          {
            if (initiate==0)
            {
              out.println("Error: Use 'initiate' first!");
              out.flush();
            }
            else
            {
              str_rnd=s.GetParamStr(g.instrRND);

              out.println("Ok");
              out.flush();
            }
          }
          else
          {
            out.println("Error: Unknown instruction!");
            out.flush();
          }
        }
      }
    }
    catch (IOException e) 
    {
//It may happen when connection is closed
//      System.out.println("Error: Problems during communication!");
      return;
    }
  }      

  //**************************************************************************
  void Go(PrintWriter out,
          CGlobal g,
          BufferedWriter fout,
          String str_dir,
          String str_fp,
          String str_ft,
          String str_strat,
          String str_step,
          String str_prec,
          String str_opt,
          String str_nt,
          String str_rt)
  {
    int ret=0;
    int i=0;

    int step=0;
    try
    {
      step=Integer.valueOf(str_step).intValue();
    }
    catch (NumberFormatException nfe1)
    {}

    String str1=str_dir+str_fp;
    String str2=str_dir+str_ft;

    //Dealing with project
    CProject cp = new CProject();

    if (cp.Init(g.lng, str1, 4096)!=0)
    {
      out.println("Error (internal): Can't initialize object CProject!");
      out.flush();
      return;
    }

    if (cp.Parse()<0)
    {
      out.println(cp.GetLastError());
      out.flush();
      return;
    }
    if (cp.ParseLng()<0)
    {
      out.println(cp.GetLastError());
      out.flush();
      return;
    }

    //Dealing with tree
    CTree ctr = new CTree();

    if (ctr.Init(str2, 4096)!=0)
    {
      out.println("Error (internal): Can't initialize object CTree!");
      out.flush();
      return;
    }

    if (ctr.Parse()<0)
    {
      out.println(ctr.GetLastError());
      out.flush();
      return;
    }

    //Create CClient for Compilation Server
    CClient cl=new CClient();
    if (cl.Init(g.cfg.GetParamStr(g.cfgCSerHost),
                g.cfg.GetParamInt(g.cfgCSerPort),
                8192)!=0)
    {
      out.println("Error (internal): Can't initialize object CClient!");
      out.flush();
      return;
    }

    CTime ct=new CTime();

    //Start output
    try
    {
      fout.write("*****************************************************************************");
      fout.newLine();

      fout.write("Project filename : ");
      fout.write(str_fp);
      fout.newLine();
      fout.write("Directory        : ");
      fout.write(str_dir);
      fout.newLine();
      fout.write("Input tree file  : ");
      fout.write(str_ft);
      fout.newLine();
      fout.write("Strategy         : ");
      fout.write(str_strat);
      fout.newLine();
      fout.write("Optimization     : ");
      fout.write(str_opt);
      fout.newLine();
      fout.write("Precision        : ");
      fout.write(str_prec);
      fout.newLine();
      fout.write("*****************************************************************************");
      fout.newLine();
      fout.flush();
      
      if (ctr.GetNumProcs()==0)
      {
        fout.write("Error: No selected arrays or loops in tree file!");
        fout.newLine();
      }

      //Compiling and running original applications
//      for (int opt=1; opt<=g.cfg.GetParamInt(g.cfgNumOptim); opt++)
//      {
//        String s_opt=String.valueOf(opt);
        String s_opt=String.valueOf(str_opt);

        fout.write("Compiling (optimization="+s_opt+"), running & coping output files ...");
        fout.newLine();
        fout.newLine();
        fout.write("  Compiling:     ");
        fout.flush();

        cl.Add("initiate compilation",   true, true);
        cl.Add("directory="+str_dir,     true, true);
        cl.Add("file_project="+str_fp,   true, true);
        cl.Add("file_diag_out="+f_tmp,   true, true);
        cl.Add("compilation_mode=0",     true, true);
        cl.Add("no_checking=0",          true, true);
        cl.Add("optimizations="+s_opt,   true, true);
        cl.Add("compile",                true, true);
        cl.Add("terminate",             false, true);

        ret=cl.Send();
        if (ret==-1)
        {
          out.println("Error: Can't find host with Compilation Server!");
          out.flush();
          return;
        }
        else if (ret==-2)
        {
          out.println("Error: Can't connect to Compilation Server!");
          out.flush();
          return;
        }
        else if (ret==-4)
        {
          out.println("Error: Can't close connection with Compilation Server!");
          out.flush();
          return;
        }
        else if (ret<0)
        {
          out.println(cl.GetLastError());
          out.flush();
          return;
        }

        fout.write("Ok");
        fout.newLine();
                             
        fout.write("  Running:       ");
        fout.flush();

        cl.Add("initiate compilation",   true, true);
        cl.Add("directory="+str_dir,     true, true);
        cl.Add("file_project="+str_fp,   true, true);
        cl.Add("file_out_time="+f_tmp1,  true, true);
        cl.Add("runmode=0",              true, true);
        cl.Add("run",                    true, true);
        cl.Add("terminate",             false, true);

        ret=cl.Send();
        if (ret==-1)
        {
          out.println("Error: Can't find host with Compilation Server!");
          out.flush();
          return;
        }
        else if (ret==-2)
        {
          out.println("Error: Can't connect to Compilation Server!");
          out.flush();
          return;
        }
        else if (ret==-4)
        {
          out.println("Error: Can't close connection with Compilation Server!");
          out.flush();
          return;
        }
        else if (ret<0)
        {
          out.println(cl.GetLastError());
          out.flush();
          return;
        }

        fout.write("Ok");
        fout.newLine();
        fout.flush();

        //Get time
        if (ct.Init(str_dir+f_tmp1)<0)
        {
          out.println(ct.GetLastError());
          out.flush();
          return;
        }

        ct.Align(5,1);

        fout.write("                                          [Time: ");
        fout.write(ct.GetTimeStr1());
        fout.write(" + ");      
        fout.write(ct.GetTimeStr2());
        fout.write(" = ");
        fout.write(ct.GetTimeStr0());
        fout.write("]");
        fout.newLine();
        fout.newLine();
//      }

      //Initializing CTransformations
      CTransformations ctrans=new CTransformations();
      if (ctrans.Init(8192, ctr, cl, cp, g,
                      str_dir, str_fp, f_tmp, 
                      str_opt, str_rt)<0)
      {
        out.println(ctrans.GetLastError());
        out.flush();
        return;
      }

      CTime ct1=ctrans.GetTime();
      ct1.Align(5,1);

      //Choosing search strategy
      if (str_strat.equals("1a"))
      {
        Strategy1a(out, g, fout,
                   cp, ctr, cl, ct1, ctrans,
                   step, str_prec, str_opt, str_nt);
      }
      else if (str_strat.equals("1b"))
      {
        Strategy1b(out, g, fout,
                   cp, ctr, cl, ct1, ctrans,
                   step, str_prec, str_opt, str_nt);
      }
      else if (str_strat.equals("3"))
      {
        Strategy3(out, g, fout,
                  cp, ctr, cl, ct1, ctrans,
                  step, str_prec, str_opt, str_nt);
      }
      else if (str_strat.equals("3a"))
      {
        Strategy3a(out, g, fout,
                   cp, ctr, cl, ct1, ctrans,
                   step, str_prec, str_opt, str_nt);
      }
      else
      {
        fout.write("Error: Unknown strategy!");
        fout.newLine();
      }

      fout.write("*****************************************************************************");
      fout.newLine();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }
  }

  //**************************************************************************
  void Strategy1a(PrintWriter out,
                  CGlobal g,
                  BufferedWriter fout,
                  CProject cp,
                  CTree ctr,
                  CClient cl,
                  CTime ct1,
                  CTransformations ctrans,
                  int step1,
                  String str_prec,
                  String str_opt,
                  String str_nt)
  {          
    int ret=0;

    int step=0;

    boolean transf=true;
    if (str_nt.equals("1")) transf=false;

    double prec=0;
    try
    {
      prec=Double.valueOf(str_prec).doubleValue();
    }
    catch (NumberFormatException nfe1)
    {
      prec=0;
    }

    CTime ct;

    Random rand=new Random((new Date()).getTime());

    int i=0;
    int p=0;
    int j=0;

    int nac=ctr.GetNumArraysComm();

    int a_max=16;          //50
    int a_step=1;

    int a_max1=0;          //10
    int a_range1=a_max;

    int l_t_max=16;        //128
    int l_u_max=16;        //128

//    double best_time=-1;
    double best_time=ct1.GetTime0();
    CTime bt=new CTime();
    bt.Copy(ct1);
    int s_best=-1;
    int transf_pos=0;

    try
    {
      fout.write("*****************************************************************************");
      fout.newLine();
      fout.flush();

      //Common array transformations
      if (nac!=0)
      {
        int[] Pad1=new int [nac];
        int[] Pad2=new int [nac];

        //Common array padding [sequental]
        for (int as1=0; as1<a_max; as1++)
        {
          step++;

          fout.write(CMisc.align_long(step, 5));
          fout.write(") Common array padding");
          fout.newLine();
          fout.newLine();

          if (step<step1)
          {
            fout.write("         OFF");
            fout.newLine();
            fout.flush();
          }
          else
          {
            ctrans.RestoreQueuePosition(transf_pos);
    
            int pad=0;
            for (i=0; i<nac; i++)
            {
              pad=(as1*a_step)+1;
              Pad1[i]=pad;

              String s_pad=String.valueOf(pad);
    
              fout.write("         array ");
              fout.write(ctr.GetNameAC(i));
              fout.write(" -> ");
              fout.write(s_pad);
              fout.newLine();
 
              if (pad>0)
              {
                ctrans.Add(0, 0, 0, i, s_pad, "", false);
              }
            }

            fout.newLine();
            fout.flush();

            ret=ctrans.Transform(transf, step);
            if (ret<0)
            {
              out.println(ctrans.GetLastError());
              out.flush();
              return;
            }
            else if (ret==1)
            {
              fout.write("                                          [");
              fout.write("exe was not created ...]");
              fout.newLine();
            }
            else if (ret==2)
            {
              fout.write("                                          [");
              fout.write("output is incorrect ...]");
              fout.newLine();
            }
            else if (ret==3)
            {
              fout.write("                                          [");
              fout.write("can't transform ...    ]");
              fout.newLine();
            }
            else if (ret==0)
            {
              ct=ctrans.GetTime();
              ct.Align(5,1);

              double tnew=ct.GetTime0();
   
              fout.write("                            (transformed) [Time: ");
              fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
              fout.write("]");
              fout.newLine();
   
              fout.write("                                   (best) [Time: ");
              fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
              fout.write("]");
              fout.newLine();

              fout.write("                               (original) [Time: ");
              fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
              fout.write("]");
              fout.newLine();

              double dt=best_time-tnew;
              if (dt>=prec)
              {
                fout.newLine();
                fout.write("                           *** BETTER *** [Time: ");
                fout.write("                    ");
                fout.write(CMisc.align_double(dt,5,1));
                fout.write("]");
                fout.newLine();

                boolean copy=false;
                if (best_time==-1)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  s_best=step;
                  copy=true;
                }
                else if (best_time>tnew)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  s_best=step;
                  copy=true;
                }

                if (copy)
                {
                  for (i=0; i<nac; i++) Pad2[i]=Pad1[i];
                }
              }
            }

            fout.newLine();
            fout.flush();
          }
        }

        //Common array padding [random]
        for (int as1=0; as1<a_max1; as1++)
        {
          step++;

          fout.write(CMisc.align_long(step, 5));
          fout.write(") Common array padding");
          fout.newLine();
          fout.newLine();

          if (step<step1)
          {
            fout.write("         OFF");
            fout.newLine();
            fout.flush();
          }
          else
          {
            ctrans.RestoreQueuePosition(transf_pos);
    
            int pad=0;
            for (i=0; i<nac; i++)
            {
              pad=Math.round(rand.nextFloat()*a_range1);
              Pad1[i]=pad;

              String s_pad=String.valueOf(pad);
    
              fout.write("         array ");
              fout.write(ctr.GetNameAC(i));
              fout.write(" -> ");
              fout.write(s_pad);
              fout.newLine();
 
              if (pad>0)
              {
                ctrans.Add(0, 0, 0, i, s_pad, "", false);
              }
            }

            fout.newLine();
            fout.flush();

            ret=ctrans.Transform(transf, step);
            if (ret<0)
            {
              out.println(ctrans.GetLastError());
              out.flush();
              return;
            }
            else if (ret==1)
            {
              fout.write("                                          [");
              fout.write("exe was not created ...]");
              fout.newLine();
            }
            else if (ret==2)
            {
              fout.write("                                          [");
              fout.write("output is incorrect ...]");
              fout.newLine();
            }
            else if (ret==3)
            {
              fout.write("                                          [");
              fout.write("can't transform ...    ]");
              fout.newLine();
            }
            else if (ret==0)
            {
              ct=ctrans.GetTime();
              ct.Align(5,1);

              double tnew=ct.GetTime0();
   
              fout.write("                            (transformed) [Time: ");
              fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
              fout.write("]");
              fout.newLine();
   
              fout.write("                                   (best) [Time: ");
              fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
              fout.write("]");
              fout.newLine();

              fout.write("                               (original) [Time: ");
              fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
              fout.write("]");
              fout.newLine();

              double dt=best_time-tnew;
              if (dt>=prec)
              {
                fout.newLine();
                fout.write("                           *** BETTER *** [Time: ");
                fout.write("                    ");
                fout.write(CMisc.align_double(dt,5,1));
                fout.write("]");
                fout.newLine();

                boolean copy=false;
                if (best_time==-1)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  s_best=step;
                  copy=true;
                }
                else if (best_time>tnew)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  s_best=step;
                  copy=true;
                }

                if (copy)
                {
                  for (i=0; i<nac; i++) Pad2[i]=Pad1[i];
                }
              }
            }

            fout.newLine();
            fout.flush();
          }
        }

        //Choosing best transformation
        fout.write("-----------------------------------------------------------------------------");
        fout.newLine();
      
        if (best_time!=-1)
        {
          fout.write("Best transformation for common arrays was found (step=");
          fout.write(String.valueOf(s_best));
          fout.write("):");
          fout.newLine();
          fout.newLine();

          ctrans.RestoreQueuePosition(transf_pos);

          for (i=0; i<nac; i++)
          {
            int pad=Pad2[i];
            String s_pad=String.valueOf(pad);
      
            fout.write("         array ");
            fout.write(ctr.GetNameAC(i));
            fout.write(" -> ");
            fout.write(s_pad);
            fout.newLine();
 
            if (pad>0)
            {
              ctrans.Add(0, 0, 0, i, s_pad, "", false);
            }
          }

          transf_pos=ctrans.GetQueuePosition();

          fout.newLine();
          fout.write("Next transformations will include the above transformation!");
          fout.newLine();        
        }
        else
        {
          transf_pos=0;

          fout.write("Best transformation for common arrays was not found!");
          fout.newLine();
        }

        fout.write("-----------------------------------------------------------------------------");
        fout.newLine();
      }

      fout.flush();

      //Loop or Array transformations
      int np=ctr.GetNumProcs();

      for (p=0; p<np; p++)
      {
        fout.write("*****************************************************************************");
        fout.newLine();
        fout.write("Procedure: ");
        fout.write(ctr.GetProc(p));
        fout.newLine();
        fout.newLine();

        //Array transformations
        int na=ctr.GetNumArrays(p);

        boolean best_found=false;

        if (na!=0)
        {
          int[] Pad1=new int [na];
          int[] Pad2=new int [na];

          //Array padding [sequental]
          for (int as1=0; as1<a_max; as1++)
          {
            step++;

            fout.write(CMisc.align_long(step, 5));
            fout.write(") Array padding");
            fout.newLine();
            fout.newLine();

            if (step<step1)
            {
              fout.write("         OFF");
              fout.newLine();
              fout.flush();
            }
            else
            {
              ctrans.RestoreQueuePosition(transf_pos);
    
              int pad=0;
              for (i=0; i<na; i++)
              {
                pad=(as1*a_step)+1;
                Pad1[i]=pad;

                String s_pad=String.valueOf(pad);
     
                fout.write("         array ");
                fout.write(ctr.GetNameA(p,i));
                fout.write(" -> ");
                fout.write(s_pad);
                fout.newLine();
 
                if (pad>0)
                {
                  ctrans.Add(1, 0, p, i, s_pad, "", false);
                }
              }

              fout.newLine();
              fout.flush();

              ret=ctrans.Transform(transf, step);
              if (ret<0)
              {
                out.println(ctrans.GetLastError());
                out.flush();
                return;
              }
              else if (ret==1)
              {
                fout.write("                                          [");
                fout.write("exe was not created ...]");
                fout.newLine();
              }
              else if (ret==2)
              {
                fout.write("                                          [");
                fout.write("output is incorrect ...]");
                fout.newLine();
              }
              else if (ret==3)
              {
                fout.write("                                          [");
                fout.write("can't transform ...    ]");
                fout.newLine();
              }
              else if (ret==0)
              {
                ct=ctrans.GetTime();
                ct.Align(5,1);
   
                double tnew=ct.GetTime0();
   
                fout.write("                            (transformed) [Time: ");
                fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                fout.write("]");
                fout.newLine();
   
                fout.write("                                   (best) [Time: ");
                fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                fout.write("]");
                fout.newLine();

                fout.write("                               (original) [Time: ");
                fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
                fout.write("]");
                fout.newLine();

                double dt=best_time-tnew;
                if (dt>=prec)
                {
                  fout.newLine();
                  fout.write("                           *** BETTER *** [Time: ");
                  fout.write("                    ");
                  fout.write(CMisc.align_double(dt,5,1));
                  fout.write("]");
                  fout.newLine();

                  boolean copy=false;
                  if (best_time==-1)
                  {
                    best_time=tnew;
                    bt.Copy(ct);
                    s_best=step;
                    copy=true;
                    best_found=true;
                  }
                  else if (best_time>tnew)
                  {
                    best_time=tnew;
                    bt.Copy(ct);
                    s_best=step;
                    copy=true;
                    best_found=true;
                  }

                  if (copy)
                  {
                    for (i=0; i<na; i++) Pad2[i]=Pad1[i];
                  }
                }
              }

              fout.newLine();
              fout.flush();
            }
          }

          //Array padding [random]
          for (int as1=0; as1<a_max1; as1++)
          {
            step++;

            fout.write(CMisc.align_long(step, 5));
            fout.write(") Array padding");
            fout.newLine();
            fout.newLine();

            if (step<step1)
            {
              fout.write("         OFF");
              fout.newLine();
              fout.flush();
            }
            else
            {
              ctrans.RestoreQueuePosition(transf_pos);
    
              int pad=0;
              for (i=0; i<na; i++)
              {
                pad=Math.round(rand.nextFloat()*a_range1);
                Pad1[i]=pad;
  
                String s_pad=String.valueOf(pad);
    
                fout.write("         array ");
                fout.write(ctr.GetNameA(p,i));
                fout.write(" -> ");
                fout.write(s_pad);
                fout.newLine();
 
                if (pad>0)
                {
                  ctrans.Add(1, 0, p, i, s_pad, "", false);
                }
              }

              fout.newLine();
              fout.flush();

              ret=ctrans.Transform(transf, step);
              if (ret<0)
              {
                out.println(ctrans.GetLastError());
                out.flush();
                return;
              }
              else if (ret==1)
              {
                fout.write("                                          [");
                fout.write("exe was not created ...]");
                fout.newLine();
              }
              else if (ret==2)
              {
                fout.write("                                          [");
                fout.write("output is incorrect ...]");
                fout.newLine();
              }
              else if (ret==3)
              {
                fout.write("                                          [");
                fout.write("can't transform ...    ]");
                fout.newLine();
              }
              else if (ret==0)
              {
                ct=ctrans.GetTime();
                ct.Align(5,1);

                double tnew=ct.GetTime0();
   
                fout.write("                            (transformed) [Time: ");
                fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                fout.write("]");
                fout.newLine();
   
                fout.write("                                   (best) [Time: ");
                fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                fout.write("]");
                fout.newLine();

                fout.write("                               (original) [Time: ");
                fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
                fout.write("]");
                fout.newLine();
 
                double dt=best_time-tnew;
                if (dt>=prec)
                {
                  fout.newLine();
                  fout.write("                           *** BETTER *** [Time: ");
                  fout.write("                    ");
                  fout.write(CMisc.align_double(dt,5,1));
                  fout.write("]");
                  fout.newLine();

                  boolean copy=false;
                  if (best_time==-1)
                  {
                    best_time=tnew;
                    bt.Copy(ct);
                    s_best=step;
                    copy=true;
                    best_found=true;
                  }
                  else if (best_time>tnew)
                  {
                    best_time=tnew;
                    bt.Copy(ct);
                    s_best=step;
                    copy=true;
                    best_found=true;
                  }

                  if (copy)
                  {
                    for (i=0; i<na; i++) Pad2[i]=Pad1[i];
                  }
                }
              }
  
              fout.newLine();
              fout.flush();
            }
          }

          //Choosing best transformation
          if (best_found)
          {
            best_found=false;

            fout.write("-----------------------------------------------------------------------------");
            fout.newLine();
  
            fout.write("Best transformation for arrays was found (step=");
            fout.write(String.valueOf(s_best));
            fout.write("):");
            fout.newLine();
            fout.newLine();

            ctrans.RestoreQueuePosition(transf_pos);

            for (i=0; i<na; i++)
            {
              int pad=Pad2[i];
              String s_pad=String.valueOf(pad);
        
              fout.write("         array ");
              fout.write(ctr.GetNameA(p,i));
              fout.write(" -> ");
              fout.write(s_pad);
              fout.newLine();
 
              if (pad>0)
              {
                ctrans.Add(1, 0, p, i, s_pad, "", false);
              }
            }

            transf_pos=ctrans.GetQueuePosition();

            fout.newLine();
            fout.write("Next transformations will include the above transformation!");
            fout.newLine();        

            fout.write("-----------------------------------------------------------------------------");
            fout.newLine();
          }
        }

        //Loop transformations
        int nl=ctr.GetNumLoops(p);

        best_found=false;
        int     best_type=0;
        int     best_i=0;
        String  best_s="";

        if (nl!=0)
        {
          String s_tile="";
          String s_unrl="";

          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
              //loop tiling
              for (j=2; j<=l_t_max; j++)
              {
                step++;

                fout.write(CMisc.align_long(step, 5));
                fout.write(") Loop tiling");
                fout.newLine();
                fout.newLine();

                if (step<step1)
                {
                  fout.write("         OFF");
                  fout.newLine();
                  fout.flush();
                }
                else
                {
                  ctrans.RestoreQueuePosition(transf_pos);

                  fout.write("         procedure: ");
                  fout.write(ctr.GetProcL(p, i));
                  fout.newLine();

                  fout.write("     loop variable: ");
                  fout.write(ctr.GetNameL(p, i));
                  fout.newLine();

                  fout.write("        loop index: ");
                  fout.write(ctr.GetCountL(p, i));
                  fout.newLine();

                  s_tile=String.valueOf(j);
                  fout.write("       tile factor: ");
                  fout.write(s_tile);
                  fout.newLine();

                  ctrans.Add(2, 2, p, i, s_tile, "", true);

                  fout.newLine();
                  fout.flush();

                  ret=ctrans.Transform(transf, step);
                  if (ret<0)
                  {
                    out.println(ctrans.GetLastError());
                    out.flush();
                    return;
                  }
                  else if (ret==1)
                  {
                    fout.write("                                          [");
                    fout.write("exe was not created ...]");
                    fout.newLine();
                  }
                  else if (ret==2)
                  {
                    fout.write("                                          [");
                    fout.write("output is incorrect ...]");
                    fout.newLine();
                  }
                  else if (ret==3)
                  {
                    fout.write("                                          [");
                    fout.write("can't transform ...    ]");
                    fout.newLine();
                  }
                  else if (ret==0)
                  {
                    ct=ctrans.GetTime();
                    ct.Align(5,1);

                    double tnew=ct.GetTime0();
  
                    fout.write("                            (transformed) [Time: ");
                    fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();
      
                    fout.write("                                   (best) [Time: ");
                    fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();

                    fout.write("                               (original) [Time: ");
                    fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();
   
                    double dt=best_time-tnew;
                    if (dt>=prec)
                    {
                      fout.newLine();
                      fout.write("                           *** BETTER *** [Time: ");
                      fout.write("                    ");
                      fout.write(CMisc.align_double(dt,5,1));
                      fout.write("]");
                      fout.newLine();

                      if (best_time==-1)
                      {
                        best_time=tnew;
                        bt.Copy(ct);
                        s_best=step;
                        best_i=i;
                        best_type=2;
                        best_s=s_tile;
                        best_found=true;
                      }
                      else if (best_time>tnew)
                      {
                        best_time=tnew;
                        bt.Copy(ct);
                        s_best=step;
                        best_i=i;
                        best_type=2;
                        best_s=s_tile;
                        best_found=true;
                      }
                    }
                  }

                  fout.newLine();
                  fout.flush();
                }
              }
            }
            else
            {
              //loop unrolling
              for (j=2; j<=l_u_max; j++)
              {
                step++;

                fout.write(CMisc.align_long(step, 5));
                fout.write(") Loop unrolling");
                fout.newLine();
                fout.newLine();

                if (step<step1)
                {
                  fout.write("         OFF");
                  fout.newLine();
                  fout.flush();
                }
                else
                {
                  ctrans.RestoreQueuePosition(transf_pos);

                  fout.write("         procedure: ");
                  fout.write(ctr.GetProcL(p, i));
                  fout.newLine();

                  fout.write("     loop variable: ");
                  fout.write(ctr.GetNameL(p, i));
                  fout.newLine();

                  fout.write("        loop index: ");
                  fout.write(ctr.GetCountL(p, i));
                  fout.newLine();

                  s_unrl=String.valueOf(j);
                  fout.write("  unrolling factor: ");
                  fout.write(s_unrl);
                  fout.newLine();

                  ctrans.Add(2, 4, p, i, s_unrl, "", true);

                  fout.newLine();
                  fout.flush();

                  ret=ctrans.Transform(transf, step);
                  if (ret<0)
                  {
                    out.println(ctrans.GetLastError());
                    out.flush();
                    return;
                  }
                  else if (ret==1)
                  {
                    fout.write("                                          [");
                    fout.write("exe was not created ...]");
                    fout.newLine();
                  }
                  else if (ret==2)
                  {
                    fout.write("                                          [");
                    fout.write("output is incorrect ...]");
                    fout.newLine();
                  }
                  else if (ret==3)
                  {
                    fout.write("                                          [");
                    fout.write("can't transform ...    ]");
                    fout.newLine();
                  }
                  else if (ret==0)
                  {
                    ct=ctrans.GetTime();
                    ct.Align(5,1);

                    double tnew=ct.GetTime0();
  
                    fout.write("                            (transformed) [Time: ");
                    fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();
      
                    fout.write("                                   (best) [Time: ");
                    fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();

                    fout.write("                               (original) [Time: ");
                    fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();
   
                    double dt=best_time-tnew;
                    if (dt>=prec)
                    {
                      fout.newLine();
                      fout.write("                           *** BETTER *** [Time: ");
                      fout.write("                    ");
                      fout.write(CMisc.align_double(dt,5,1));
                      fout.write("]");
                      fout.newLine();

                      if (best_time==-1)
                      {
                        best_time=tnew;
                        bt.Copy(ct);
                        s_best=step;
                        best_i=i;
                        best_type=4;
                        best_s=s_unrl;
                        best_found=true;
                      }
                      else if (best_time>tnew)
                      {
                        best_time=tnew;
                        bt.Copy(ct);
                        s_best=step;
                        best_i=i;
                        best_type=4;
                        best_s=s_unrl;
                        best_found=true;
                      }
                    }
                  }

                  fout.newLine();
                  fout.flush();
                }
              }

              //loop distribution
              step++;

              fout.write(CMisc.align_long(step, 5));
              fout.write(") Loop distribution");
              fout.newLine();
              fout.newLine();

              if (step<step1)
              {
                fout.write("         OFF");
                fout.newLine();
                fout.flush();
              }
              else
              {
                ctrans.RestoreQueuePosition(transf_pos);

                fout.write("         procedure: ");
                fout.write(ctr.GetProcL(p, i));
                fout.newLine();

                fout.write("     loop variable: ");
                fout.write(ctr.GetNameL(p, i));
                fout.newLine();

                fout.write("        loop index: ");
                fout.write(ctr.GetCountL(p, i));
                fout.newLine();

                ctrans.Add(2, 3, p, i, "", "", true);

                fout.newLine();
                fout.flush();

                ret=ctrans.Transform(transf, step);
                if (ret<0)
                {
                  out.println(ctrans.GetLastError());
                  out.flush();
                  return;
                }
                else if (ret==1)
                {
                  fout.write("                                          [");
                  fout.write("exe was not created ...]");
                  fout.newLine();
                }
                else if (ret==2)
                {
                  fout.write("                                          [");
                  fout.write("output is incorrect ...]");
                  fout.newLine();
                }
                else if (ret==3)
                {
                  fout.write("                                          [");
                  fout.write("can't transform ...    ]");
                  fout.newLine();
                }
                else if (ret==0)
                {
                  ct=ctrans.GetTime();
                  ct.Align(5,1);

                  double tnew=ct.GetTime0();

                  fout.write("                            (transformed) [Time: ");
                  fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();
      
                  fout.write("                                   (best) [Time: ");
                  fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();

                  fout.write("                               (original) [Time: ");
                  fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();
   
                  double dt=best_time-tnew;
                  if (dt>=prec)
                  {
                    fout.newLine();
                    fout.write("                           *** BETTER *** [Time: ");
                    fout.write("                    ");
                    fout.write(CMisc.align_double(dt,5,1));
                    fout.write("]");
                    fout.newLine();

                    if (best_time==-1)
                    {
                      best_time=tnew;
                      bt.Copy(ct);
                      s_best=step;
                      best_i=i;
                      best_type=3;
                      best_s="";
                      best_found=true;
                    }
                    else if (best_time>tnew)
                    {
                      best_time=tnew;
                      bt.Copy(ct);
                      s_best=step;
                      best_i=i;
                      best_type=3;
                      best_s="";
                      best_found=true;
                    }
                  }
                }

                fout.newLine();
                fout.flush();
              }

              //Choosing best transformation
              if (best_found)
              {
                best_found=false;

                //Choosing best transformation
                fout.write("-----------------------------------------------------------------------------");
                fout.newLine();
 
                fout.write("Best transformation for loop ");
                fout.write(ctr.GetCountL(p, best_i));
                fout.write(" found (step=");
                fout.write(String.valueOf(s_best));
                fout.write(")!");
                fout.newLine();

                ctrans.RestoreQueuePosition(transf_pos);
                ctrans.Add(2, best_type, p, best_i, best_s, "", true);
                transf_pos=ctrans.GetQueuePosition();

                fout.newLine();
                fout.write("Next transformations will include the above transformation!");
                fout.newLine();

                fout.write("-----------------------------------------------------------------------------");
                fout.newLine();

                fout.flush();
              }
            }
          }
        }
      }

      fout.write("*****************************************************************************");
      fout.newLine();

      fout.write("Result: ");
      fout.newLine();
      fout.newLine();

      if (s_best!=-1)
      {
        fout.write("                                   (best) [Time: ");
        fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
        fout.write("]");
        fout.newLine();

        fout.write("                               (original) [Time: ");
        fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
        fout.write("]");
        fout.newLine();
   
        double dt=ct1.GetTime0()-best_time;
        fout.newLine();
        fout.write("                           *** BETTER *** [Time: ");
        fout.write("                    ");
        fout.write(CMisc.align_double(dt,5,1));
        fout.write("]");
        fout.newLine();
        fout.newLine();
        
        fout.write("                                          [      ");
        fout.write("                     ");
        double dp=dt*100/ct1.GetTime0();  
        fout.write(CMisc.align_double(dp,3,1)+"%");
        fout.write("]");
        fout.newLine();
      }
      else
      {
        fout.write("Best combined transformation was not found!");
        fout.newLine();
      }
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    out.println("Ok");
    out.flush();
  }

  //**************************************************************************
  void Strategy1b(PrintWriter out,
                  CGlobal g,
                  BufferedWriter fout,
                  CProject cp,
                  CTree ctr,
                  CClient cl,
                  CTime ct1,
                  CTransformations ctrans,
                  int step1,
                  String str_prec,
                  String str_opt,
                  String str_nt)
  {          
    int ret=0;

    int step=0;

    boolean transf=true;
    if (str_nt.equals("1")) transf=false;

    double prec=0;
    try
    {
      prec=Double.valueOf(str_prec).doubleValue();
    }
    catch (NumberFormatException nfe1)
    {
      prec=0;
    }

    CTime ct;

    Random rand=new Random((new Date()).getTime());

    int i=0;
    int p=0;
    int j=0;

    int nac=ctr.GetNumArraysComm();

    int a_max=20;          //50
    int a_step=1;

    int a_max1=0;          //10
    int a_range1=a_max;

    int l_t_max=15;        //128
    int l_u_max=15;        //128

//    double best_time=-1;
    double best_time=ct1.GetTime0();
    CTime bt=new CTime();
    bt.Copy(ct1);
    int s_best=-1;
    int transf_pos=0;

    try
    {
      //Loop or Array transformations
      int np=ctr.GetNumProcs();

      for (p=0; p<np; p++)
      {
        fout.write("*****************************************************************************");
        fout.newLine();
        fout.write("Procedure: ");
        fout.write(ctr.GetProc(p));
        fout.newLine();
        fout.newLine();

        //Loop transformations
        int nl=ctr.GetNumLoops(p);

        boolean best_found=false;
        int     best_type=0;
        int     best_i=0;
        String  best_s="";

        if (nl!=0)
        {
          String s_tile="";
          String s_unrl="";

          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
              //loop tiling
              for (j=2; j<=l_t_max; j++)
              {
                step++;

                fout.write(CMisc.align_long(step, 5));
                fout.write(") Loop tiling");
                fout.newLine();
                fout.newLine();

                if (step<step1)
                {
                  fout.write("         OFF");
                  fout.newLine();
                  fout.flush();
                }
                else
                {
                  ctrans.RestoreQueuePosition(transf_pos);

                  fout.write("         procedure: ");
                  fout.write(ctr.GetProcL(p, i));
                  fout.newLine();

                  fout.write("     loop variable: ");
                  fout.write(ctr.GetNameL(p, i));
                  fout.newLine();

                  fout.write("        loop index: ");
                  fout.write(ctr.GetCountL(p, i));
                  fout.newLine();

                  s_tile=String.valueOf(j);
                  fout.write("       tile factor: ");
                  fout.write(s_tile);
                  fout.newLine();

                  ctrans.Add(2, 2, p, i, s_tile, "", true);

                  fout.newLine();
                  fout.flush();

                  ret=ctrans.Transform(transf, step);
                  if (ret<0)
                  {
                    out.println(ctrans.GetLastError());
                    out.flush();
                    return;
                  }
                  else if (ret==1)
                  {
                    fout.write("                                          [");
                    fout.write("exe was not created ...]");
                    fout.newLine();
                  }
                  else if (ret==2)
                  {
                    fout.write("                                          [");
                    fout.write("output is incorrect ...]");
                    fout.newLine();
                  }
                  else if (ret==3)
                  {
                    fout.write("                                          [");
                    fout.write("can't transform ...    ]");
                    fout.newLine();
                  }
                  else if (ret==0)
                  {
                    ct=ctrans.GetTime();
                    ct.Align(5,1);

                    double tnew=ct.GetTime0();
  
                    fout.write("                            (transformed) [Time: ");
                    fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();
      
                    fout.write("                                   (best) [Time: ");
                    fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();

                    fout.write("                               (original) [Time: ");
                    fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();
   
                    double dt=best_time-tnew;
                    if (dt>=prec)
                    {
                      fout.newLine();
                      fout.write("                           *** BETTER *** [Time: ");
                      fout.write("                    ");
                      fout.write(CMisc.align_double(dt,5,1));
                      fout.write("]");
                      fout.newLine();

                      if (best_time==-1)
                      {
                        best_time=tnew;
                        bt.Copy(ct);
                        s_best=step;
                        best_i=i;
                        best_type=2;
                        best_s=s_tile;
                        best_found=true;
                      }
                      else if (best_time>tnew)
                      {
                        best_time=tnew;
                        bt.Copy(ct);
                        s_best=step;
                        best_i=i;
                        best_type=2;
                        best_s=s_tile;
                        best_found=true;
                      }
                    }
                  }

                  fout.newLine();
                  fout.flush();
                }
              }
            }
            else
            {
              //loop unrolling
              for (j=2; j<=l_u_max; j++)
              {
                step++;

                fout.write(CMisc.align_long(step, 5));
                fout.write(") Loop unrolling");
                fout.newLine();
                fout.newLine();

                if (step<step1)
                {
                  fout.write("         OFF");
                  fout.newLine();
                  fout.flush();
                }
                else
                {
                  ctrans.RestoreQueuePosition(transf_pos);

                  fout.write("         procedure: ");
                  fout.write(ctr.GetProcL(p, i));
                  fout.newLine();

                  fout.write("     loop variable: ");
                  fout.write(ctr.GetNameL(p, i));
                  fout.newLine();

                  fout.write("        loop index: ");
                  fout.write(ctr.GetCountL(p, i));
                  fout.newLine();

                  s_unrl=String.valueOf(j);
                  fout.write("  unrolling factor: ");
                  fout.write(s_unrl);
                  fout.newLine();

                  ctrans.Add(2, 4, p, i, s_unrl, "", true);

                  fout.newLine();
                  fout.flush();

                  ret=ctrans.Transform(transf, step);
                  if (ret<0)
                  {
                    out.println(ctrans.GetLastError());
                    out.flush();
                    return;
                  }
                  else if (ret==1)
                  {
                    fout.write("                                          [");
                    fout.write("exe was not created ...]");
                    fout.newLine();
                  }
                  else if (ret==2)
                  {
                    fout.write("                                          [");
                    fout.write("output is incorrect ...]");
                    fout.newLine();
                  }
                  else if (ret==3)
                  {
                    fout.write("                                          [");
                    fout.write("can't transform ...    ]");
                    fout.newLine();
                  }
                  else if (ret==0)
                  {
                    ct=ctrans.GetTime();
                    ct.Align(5,1);

                    double tnew=ct.GetTime0();
  
                    fout.write("                            (transformed) [Time: ");
                    fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();
      
                    fout.write("                                   (best) [Time: ");
                    fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();

                    fout.write("                               (original) [Time: ");
                    fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
                    fout.write("]");
                    fout.newLine();
   
                    double dt=best_time-tnew;
                    if (dt>=prec)
                    {
                      fout.newLine();
                      fout.write("                           *** BETTER *** [Time: ");
                      fout.write("                    ");
                      fout.write(CMisc.align_double(dt,5,1));
                      fout.write("]");
                      fout.newLine();

                      if (best_time==-1)
                      {
                        best_time=tnew;
                        bt.Copy(ct);
                        s_best=step;
                        best_i=i;
                        best_type=4;
                        best_s=s_unrl;
                        best_found=true;
                      }
                      else if (best_time>tnew)
                      {
                        best_time=tnew;
                        bt.Copy(ct);
                        s_best=step;
                        best_i=i;
                        best_type=4;
                        best_s=s_unrl;
                        best_found=true;
                      }
                    }
                  }

                  fout.newLine();
                  fout.flush();
                }
              }

              //loop distribution
              step++;

              fout.write(CMisc.align_long(step, 5));
              fout.write(") Loop distribution");
              fout.newLine();
              fout.newLine();

              if (step<step1)
              {
                fout.write("         OFF");
                fout.newLine();
                fout.flush();
              }
              else
              {
                ctrans.RestoreQueuePosition(transf_pos);

                fout.write("         procedure: ");
                fout.write(ctr.GetProcL(p, i));
                fout.newLine();

                fout.write("     loop variable: ");
                fout.write(ctr.GetNameL(p, i));
                fout.newLine();

                fout.write("        loop index: ");
                fout.write(ctr.GetCountL(p, i));
                fout.newLine();

                ctrans.Add(2, 3, p, i, "", "", true);

                fout.newLine();
                fout.flush();

                ret=ctrans.Transform(transf, step);
                if (ret<0)
                {
                  out.println(ctrans.GetLastError());
                  out.flush();
                  return;
                }
                else if (ret==1)
                {
                  fout.write("                                          [");
                  fout.write("exe was not created ...]");
                  fout.newLine();
                }
                else if (ret==2)
                {
                  fout.write("                                          [");
                  fout.write("output is incorrect ...]");
                  fout.newLine();
                }
                else if (ret==3)
                {
                  fout.write("                                          [");
                  fout.write("can't transform ...    ]");
                  fout.newLine();
                }
                else if (ret==0)
                {
                  ct=ctrans.GetTime();
                  ct.Align(5,1);

                  double tnew=ct.GetTime0();

                  fout.write("                            (transformed) [Time: ");
                  fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();
      
                  fout.write("                                   (best) [Time: ");
                  fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();

                  fout.write("                               (original) [Time: ");
                  fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
                  fout.write("]");
                  fout.newLine();
   
                  double dt=best_time-tnew;
                  if (dt>=prec)
                  {
                    fout.newLine();
                    fout.write("                           *** BETTER *** [Time: ");
                    fout.write("                    ");
                    fout.write(CMisc.align_double(dt,5,1));
                    fout.write("]");
                    fout.newLine();

                    if (best_time==-1)
                    {
                      best_time=tnew;
                      bt.Copy(ct);
                      s_best=step;
                      best_i=i;
                      best_type=3;
                      best_s="";
                      best_found=true;
                    }
                    else if (best_time>tnew)
                    {
                      best_time=tnew;
                      bt.Copy(ct);
                      s_best=step;
                      best_i=i;
                      best_type=3;
                      best_s="";
                      best_found=true;
                    }
                  }
                }

                fout.newLine();
                fout.flush();
              }

              //Choosing best transformation
              if (best_found)
              {
                best_found=false;

                //Choosing best transformation
                fout.write("-----------------------------------------------------------------------------");
                fout.newLine();
 
                fout.write("Best transformation for loop ");
                fout.write(ctr.GetCountL(p, best_i));
                fout.write(" found (step=");
                fout.write(String.valueOf(s_best));
                fout.write(")!");
                fout.newLine();

                ctrans.RestoreQueuePosition(transf_pos);
                ctrans.Add(2, best_type, p, best_i, best_s, "", true);
                transf_pos=ctrans.GetQueuePosition();

                fout.newLine();
                fout.write("Next transformations will include the above transformation!");
                fout.newLine();

                fout.write("-----------------------------------------------------------------------------");
                fout.newLine();

                fout.flush();
              }
            }
          }
        }

        //Array transformations
        int na=ctr.GetNumArrays(p);

        best_found=false;

        if (na!=0)
        {
          int[] Pad1=new int [na];
          int[] Pad2=new int [na];

          //Array padding [sequental]
          for (int as1=0; as1<a_max; as1++)
          {
            step++;

            fout.write(CMisc.align_long(step, 5));
            fout.write(") Array padding");
            fout.newLine();
            fout.newLine();

            if (step<step1)
            {
              fout.write("         OFF");
              fout.newLine();
              fout.flush();
            }
            else
            {
              ctrans.RestoreQueuePosition(transf_pos);
    
              int pad=0;
              for (i=0; i<na; i++)
              {
                pad=(as1*a_step)+1;
                Pad1[i]=pad;

                String s_pad=String.valueOf(pad);
     
                fout.write("         array ");
                fout.write(ctr.GetNameA(p,i));
                fout.write(" -> ");
                fout.write(s_pad);
                fout.newLine();
 
                if (pad>0)
                {
                  ctrans.Add(1, 0, p, i, s_pad, "", false);
                }
              }

              fout.newLine();
              fout.flush();

              ret=ctrans.Transform(transf, step);
              if (ret<0)
              {
                out.println(ctrans.GetLastError());
                out.flush();
                return;
              }
              else if (ret==1)
              {
                fout.write("                                          [");
                fout.write("exe was not created ...]");
                fout.newLine();
              }
              else if (ret==2)
              {
                fout.write("                                          [");
                fout.write("output is incorrect ...]");
                fout.newLine();
              }
              else if (ret==3)
              {
                fout.write("                                          [");
                fout.write("can't transform ...    ]");
                fout.newLine();
              }
              else if (ret==0)
              {
                ct=ctrans.GetTime();
                ct.Align(5,1);
   
                double tnew=ct.GetTime0();
   
                fout.write("                            (transformed) [Time: ");
                fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                fout.write("]");
                fout.newLine();
   
                fout.write("                                   (best) [Time: ");
                fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                fout.write("]");
                fout.newLine();

                fout.write("                               (original) [Time: ");
                fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
                fout.write("]");
                fout.newLine();

                double dt=best_time-tnew;
                if (dt>=prec)
                {
                  fout.newLine();
                  fout.write("                           *** BETTER *** [Time: ");
                  fout.write("                    ");
                  fout.write(CMisc.align_double(dt,5,1));
                  fout.write("]");
                  fout.newLine();

                  boolean copy=false;
                  if (best_time==-1)
                  {
                    best_time=tnew;
                    bt.Copy(ct);
                    s_best=step;
                    copy=true;
                    best_found=true;
                  }
                  else if (best_time>tnew)
                  {
                    best_time=tnew;
                    bt.Copy(ct);
                    s_best=step;
                    copy=true;
                    best_found=true;
                  }

                  if (copy)
                  {
                    for (i=0; i<na; i++) Pad2[i]=Pad1[i];
                  }
                }
              }

              fout.newLine();
              fout.flush();
            }
          }

          //Array padding [random]
          for (int as1=0; as1<a_max1; as1++)
          {
            step++;

            fout.write(CMisc.align_long(step, 5));
            fout.write(") Array padding");
            fout.newLine();
            fout.newLine();

            if (step<step1)
            {
              fout.write("         OFF");
              fout.newLine();
              fout.flush();
            }
            else
            {
              ctrans.RestoreQueuePosition(transf_pos);
    
              int pad=0;
              for (i=0; i<na; i++)
              {
                pad=Math.round(rand.nextFloat()*a_range1);
                Pad1[i]=pad;
  
                String s_pad=String.valueOf(pad);
    
                fout.write("         array ");
                fout.write(ctr.GetNameA(p,i));
                fout.write(" -> ");
                fout.write(s_pad);
                fout.newLine();
 
                if (pad>0)
                {
                  ctrans.Add(1, 0, p, i, s_pad, "", false);
                }
              }

              fout.newLine();
              fout.flush();

              ret=ctrans.Transform(transf, step);
              if (ret<0)
              {
                out.println(ctrans.GetLastError());
                out.flush();
                return;
              }
              else if (ret==1)
              {
                fout.write("                                          [");
                fout.write("exe was not created ...]");
                fout.newLine();
              }
              else if (ret==2)
              {
                fout.write("                                          [");
                fout.write("output is incorrect ...]");
                fout.newLine();
              }
              else if (ret==3)
              {
                fout.write("                                          [");
                fout.write("can't transform ...    ]");
                fout.newLine();
              }
              else if (ret==0)
              {
                ct=ctrans.GetTime();
                ct.Align(5,1);

                double tnew=ct.GetTime0();
   
                fout.write("                            (transformed) [Time: ");
                fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
                fout.write("]");
                fout.newLine();
   
                fout.write("                                   (best) [Time: ");
                fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
                fout.write("]");
                fout.newLine();

                fout.write("                               (original) [Time: ");
                fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
                fout.write("]");
                fout.newLine();
 
                double dt=best_time-tnew;
                if (dt>=prec)
                {
                  fout.newLine();
                  fout.write("                           *** BETTER *** [Time: ");
                  fout.write("                    ");
                  fout.write(CMisc.align_double(dt,5,1));
                  fout.write("]");
                  fout.newLine();

                  boolean copy=false;
                  if (best_time==-1)
                  {
                    best_time=tnew;
                    bt.Copy(ct);
                    s_best=step;
                    copy=true;
                    best_found=true;
                  }
                  else if (best_time>tnew)
                  {
                    best_time=tnew;
                    bt.Copy(ct);
                    s_best=step;
                    copy=true;
                    best_found=true;
                  }

                  if (copy)
                  {
                    for (i=0; i<na; i++) Pad2[i]=Pad1[i];
                  }
                }
              }
  
              fout.newLine();
              fout.flush();
            }
          }

          //Choosing best transformation
          if (best_found)
          {
            best_found=false;

            fout.write("-----------------------------------------------------------------------------");
            fout.newLine();
  
            fout.write("Best transformation for arrays was found (step=");
            fout.write(String.valueOf(s_best));
            fout.write("):");
            fout.newLine();
            fout.newLine();

            ctrans.RestoreQueuePosition(transf_pos);

            for (i=0; i<na; i++)
            {
              int pad=Pad2[i];
              String s_pad=String.valueOf(pad);
        
              fout.write("         array ");
              fout.write(ctr.GetNameA(p,i));
              fout.write(" -> ");
              fout.write(s_pad);
              fout.newLine();
 
              if (pad>0)
              {
                ctrans.Add(1, 0, p, i, s_pad, "", false);
              }
            }

            transf_pos=ctrans.GetQueuePosition();

            fout.newLine();
            fout.write("Next transformations will include the above transformation!");
            fout.newLine();        

            fout.write("-----------------------------------------------------------------------------");
            fout.newLine();
          }
        }
      }

      fout.write("*****************************************************************************");
      fout.newLine();

      //Common array transformations
      if (nac!=0)
      {
        int[] Pad1=new int [nac];
        int[] Pad2=new int [nac];

        //Common array padding [sequental]
        for (int as1=0; as1<a_max; as1++)
        {
          step++;

          fout.write(CMisc.align_long(step, 5));
          fout.write(") Common array padding");
          fout.newLine();
          fout.newLine();

          if (step<step1)
          {
            fout.write("         OFF");
            fout.newLine();
            fout.flush();
          }
          else
          {
            ctrans.RestoreQueuePosition(transf_pos);
    
            int pad=0;
            for (i=0; i<nac; i++)
            {
              pad=(as1*a_step)+1;
              Pad1[i]=pad;

              String s_pad=String.valueOf(pad);
    
              fout.write("         array ");
              fout.write(ctr.GetNameAC(i));
              fout.write(" -> ");
              fout.write(s_pad);
              fout.newLine();
 
              if (pad>0)
              {
                ctrans.Add(0, 0, 0, i, s_pad, "", false);
              }
            }

            fout.newLine();
            fout.flush();

            ret=ctrans.Transform(transf, step);
            if (ret<0)
            {
              out.println(ctrans.GetLastError());
              out.flush();
              return;
            }
            else if (ret==1)
            {
              fout.write("                                          [");
              fout.write("exe was not created ...]");
              fout.newLine();
            }
            else if (ret==2)
            {
              fout.write("                                          [");
              fout.write("output is incorrect ...]");
              fout.newLine();
            }
            else if (ret==3)
            {
              fout.write("                                          [");
              fout.write("can't transform ...    ]");
              fout.newLine();
            }
            else if (ret==0)
            {
              ct=ctrans.GetTime();
              ct.Align(5,1);

              double tnew=ct.GetTime0();
   
              fout.write("                            (transformed) [Time: ");
              fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
              fout.write("]");
              fout.newLine();
   
              fout.write("                                   (best) [Time: ");
              fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
              fout.write("]");
              fout.newLine();

              fout.write("                               (original) [Time: ");
              fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
              fout.write("]");
              fout.newLine();

              double dt=best_time-tnew;
              if (dt>=prec)
              {
                fout.newLine();
                fout.write("                           *** BETTER *** [Time: ");
                fout.write("                    ");
                fout.write(CMisc.align_double(dt,5,1));
                fout.write("]");
                fout.newLine();

                boolean copy=false;
                if (best_time==-1)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  s_best=step;
                  copy=true;
                }
                else if (best_time>tnew)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  s_best=step;
                  copy=true;
                }

                if (copy)
                {
                  for (i=0; i<nac; i++) Pad2[i]=Pad1[i];
                }
              }
            }

            fout.newLine();
            fout.flush();
          }
        }

        //Common array padding [random]
        for (int as1=0; as1<a_max1; as1++)
        {
          step++;

          fout.write(CMisc.align_long(step, 5));
          fout.write(") Common array padding");
          fout.newLine();
          fout.newLine();

          if (step<step1)
          {
            fout.write("         OFF");
            fout.newLine();
            fout.flush();
          }
          else
          {
            ctrans.RestoreQueuePosition(transf_pos);
    
            int pad=0;
            for (i=0; i<nac; i++)
            {
              pad=Math.round(rand.nextFloat()*a_range1);
              Pad1[i]=pad;

              String s_pad=String.valueOf(pad);
    
              fout.write("         array ");
              fout.write(ctr.GetNameAC(i));
              fout.write(" -> ");
              fout.write(s_pad);
              fout.newLine();
 
              if (pad>0)
              {
                ctrans.Add(0, 0, 0, i, s_pad, "", false);
              }
            }

            fout.newLine();
            fout.flush();

            ret=ctrans.Transform(transf, step);
            if (ret<0)
            {
              out.println(ctrans.GetLastError());
              out.flush();
              return;
            }
            else if (ret==1)
            {
              fout.write("                                          [");
              fout.write("exe was not created ...]");
              fout.newLine();
            }
            else if (ret==2)
            {
              fout.write("                                          [");
              fout.write("output is incorrect ...]");
              fout.newLine();
            }
            else if (ret==3)
            {
              fout.write("                                          [");
              fout.write("can't transform ...    ]");
              fout.newLine();
            }
            else if (ret==0)
            {
              ct=ctrans.GetTime();
              ct.Align(5,1);

              double tnew=ct.GetTime0();
   
              fout.write("                            (transformed) [Time: ");
              fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
              fout.write("]");
              fout.newLine();
   
              fout.write("                                   (best) [Time: ");
              fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
              fout.write("]");
              fout.newLine();

              fout.write("                               (original) [Time: ");
              fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
              fout.write("]");
              fout.newLine();

              double dt=best_time-tnew;
              if (dt>=prec)
              {
                fout.newLine();
                fout.write("                           *** BETTER *** [Time: ");
                fout.write("                    ");
                fout.write(CMisc.align_double(dt,5,1));
                fout.write("]");
                fout.newLine();

                boolean copy=false;
                if (best_time==-1)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  s_best=step;
                  copy=true;
                }
                else if (best_time>tnew)
                {
                  best_time=tnew;
                  bt.Copy(ct);
                  s_best=step;
                  copy=true;
                }

                if (copy)
                {
                  for (i=0; i<nac; i++) Pad2[i]=Pad1[i];
                }
              }
            }

            fout.newLine();
            fout.flush();
          }
        }

        //Choosing best transformation
        fout.write("-----------------------------------------------------------------------------");
        fout.newLine();
      
        if (best_time!=-1)
        {
          fout.write("Best transformation for common arrays was found (step=");
          fout.write(String.valueOf(s_best));
          fout.write("):");
          fout.newLine();
          fout.newLine();

          ctrans.RestoreQueuePosition(transf_pos);

          for (i=0; i<nac; i++)
          {
            int pad=Pad2[i];
            String s_pad=String.valueOf(pad);
      
            fout.write("         array ");
            fout.write(ctr.GetNameAC(i));
            fout.write(" -> ");
            fout.write(s_pad);
            fout.newLine();
 
            if (pad>0)
            {
              ctrans.Add(0, 0, 0, i, s_pad, "", false);
            }
          }

          transf_pos=ctrans.GetQueuePosition();

          fout.newLine();
          fout.write("Next transformations will include the above transformation!");
          fout.newLine();        
        }
        else
        {
          transf_pos=0;

          fout.write("Best transformation for common arrays was not found!");
          fout.newLine();
        }

        fout.write("-----------------------------------------------------------------------------");
        fout.newLine();
      }

      fout.flush();

      fout.write("Result: ");
      fout.newLine();
      fout.newLine();

      if (s_best!=-1)
      {
        fout.write("                                   (best) [Time: ");
        fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
        fout.write("]");
        fout.newLine();

        fout.write("                               (original) [Time: ");
        fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
        fout.write("]");
        fout.newLine();
   
        double dt=ct1.GetTime0()-best_time;
        fout.newLine();
        fout.write("                           *** BETTER *** [Time: ");
        fout.write("                    ");
        fout.write(CMisc.align_double(dt,5,1));
        fout.write("]");
        fout.newLine();
        fout.newLine();
        
        fout.write("                                          [      ");
        fout.write("                     ");
        double dp=dt*100/ct1.GetTime0();  
        fout.write(CMisc.align_double(dp,3,1)+"%");
        fout.write("]");
        fout.newLine();
      }
      else
      {
        fout.write("Best combined transformation was not found!");
        fout.newLine();
      }
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    out.println("Ok");
    out.flush();
  }

  //**************************************************************************
  void Strategy3(PrintWriter out,
                 CGlobal g,
                 BufferedWriter fout,
                 CProject cp,
                 CTree ctr,
                 CClient cl,
                 CTime ct1,
                 CTransformations ctrans,
                 int step1,
                 String str_prec,
                 String str_opt,
                 String str_nt)
  {          
    int ret=0;

    int step=0;

    boolean transf=true;
    if (str_nt.equals("1")) transf=false;

    double prec=0;
    try
    {
      prec=Double.valueOf(str_prec).doubleValue();
    }
    catch (NumberFormatException nfe1)
    {
      prec=0;
    }

    CTime ct;

    Random rand=new Random((new Date()).getTime());

    int i=0;
    int p=0;
    int j=0;

    int nac=ctr.GetNumArraysComm();

    int step_max=15;
    int a_max   =20;        //50
    int l_t_max =20;        //128
    int l_u_max =20;        //128

    double best_time=ct1.GetTime0();
    CTime bt=new CTime();
    bt.Copy(ct1);
    int s_best=-1;

    try
    {
      for (step=1; step<=step_max; step++)
      {
        fout.write("*****************************************************************************");
        fout.newLine();
        fout.flush();

        fout.write(CMisc.align_long(step, 5));
        fout.write(")");
        fout.newLine();
        fout.newLine();

        if (step<step1)
        {
          fout.write("         OFF");
          fout.newLine();
          fout.flush();
        }
        else
        {
          boolean best_found=false;

          ctrans.RestoreQueuePosition(0);

          //Common array transformations
          if (nac!=0)
          {
            //Common array padding [random]
            fout.write("Common array padding");
            fout.newLine();
            fout.newLine();

            int pad=Math.round(rand.nextFloat()*a_max)+1;
            String s_pad=String.valueOf(pad);

            for (i=0; i<nac; i++)
            {
              fout.write("         array ");
              fout.write(ctr.GetNameAC(i));
              fout.write(" -> ");
              fout.write(s_pad);
              fout.newLine();
 
              if (pad>0)
              {
                ctrans.Add(0, 0, 0, i, s_pad, "", false);
              }
            }

            fout.newLine();
            fout.flush();
          }

          //Loop or Array transformations
          int np=ctr.GetNumProcs();

          for (p=0; p<np; p++)
          {
            fout.newLine();
            fout.write("Procedure: ");
            fout.write(ctr.GetProc(p));
            fout.newLine();
            fout.newLine();

            //Array transformations
            int na=ctr.GetNumArrays(p);

            if (na!=0)
            {
              int pad=Math.round(rand.nextFloat()*a_max)+1;
              String s_pad=String.valueOf(pad);

              for (i=0; i<na; i++)
              {
                fout.write("         array ");
                fout.write(ctr.GetNameA(p,i));
                fout.write(" -> ");
                fout.write(s_pad);
                fout.newLine();
 
                if (pad>0)
                {
                  ctrans.Add(1, 0, p, i, s_pad, "", false);
                }
              }

              fout.newLine();
              fout.flush();
            }

            //Loop transformations
            int nl=ctr.GetNumLoops(p);

            int     best_type=0;
            int     best_i=0;
            String  best_s="";

            if (nl!=0)
            {
              String s_tile="";
              String s_unrl="";

              for (i=0; i<nl; i++)
              {
                if (!ctr.GetParamL(p, i).equals("0"))
                {
                  //loop tiling
                  j=Math.round(rand.nextFloat()*l_t_max)+2;

                  fout.write("         procedure: ");
                  fout.write(ctr.GetProcL(p, i));
                  fout.newLine();

                  fout.write("     loop variable: ");
                  fout.write(ctr.GetNameL(p, i));
                  fout.newLine();

                  fout.write("        loop index: ");
                  fout.write(ctr.GetCountL(p, i));
                  fout.newLine();

                  s_tile=String.valueOf(j);
                  fout.write("       tile factor: ");
                  fout.write(s_tile);
                  fout.newLine();

                  ctrans.Add(2, 2, p, i, s_tile, "", true);

                  fout.newLine();
                  fout.flush();
                }
                else
                {
                  //loop unrolling
                  j=Math.round(rand.nextFloat()*l_u_max)+2;

                  fout.write("         procedure: ");
                  fout.write(ctr.GetProcL(p, i));
                  fout.newLine();

                  fout.write("     loop variable: ");
                  fout.write(ctr.GetNameL(p, i));
                  fout.newLine();

                  fout.write("        loop index: ");
                  fout.write(ctr.GetCountL(p, i));
                  fout.newLine();

                  s_unrl=String.valueOf(j);
                  fout.write("  unrolling factor: ");
                  fout.write(s_unrl);
                  fout.newLine();

                  ctrans.Add(2, 4, p, i, s_unrl, "", true);

                  fout.newLine();
                  fout.flush();
                }
              }
            }
          }  

          ret=ctrans.Transform(transf, step);
          if (ret<0)
          {
            out.println(ctrans.GetLastError());
            out.flush();
            return;
          }
          else if (ret==1)
          {
            fout.write("                                          [");
            fout.write("exe was not created ...]");
            fout.newLine();
          }
          else if (ret==2)
          {
            fout.write("                                          [");
            fout.write("output is incorrect ...]");
            fout.newLine();
          }
          else if (ret==3)
          {
            fout.write("                                          [");
            fout.write("can't transform ...    ]");
            fout.newLine();
          }
          else if (ret==0)
          {
            ct=ctrans.GetTime();
            ct.Align(5,1);

            double tnew=ct.GetTime0();

            fout.write("                            (transformed) [Time: ");
            fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
            fout.write("]");
            fout.newLine();
      
            fout.write("                                   (best) [Time: ");
            fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
            fout.write("]");
            fout.newLine();

            fout.write("                               (original) [Time: ");
            fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
            fout.write("]");
            fout.newLine();
   
            double dt=best_time-tnew;
            if (dt>=prec)
            {
              fout.newLine();
              fout.write("                           *** BETTER *** [Time: ");
              fout.write("                    ");
              fout.write(CMisc.align_double(dt,5,1));
              fout.write("]");
              fout.newLine();

              if (best_time==-1)
              {
                best_time=tnew;
                bt.Copy(ct);
                s_best=step;
                best_found=true;
              }
              else if (best_time>tnew)
              {
                best_time=tnew;
                bt.Copy(ct);
                s_best=step;
                best_found=true;
              }
            }
          }

          fout.newLine();
          fout.flush();
        }
      }

      fout.write("*****************************************************************************");
      fout.newLine();

      fout.write("Result: ");
      fout.newLine();
      fout.newLine();

      if (s_best!=-1)
      {
        fout.write("                                   (best) [Time: ");
        fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
        fout.write("]");
        fout.newLine();

        fout.write("                               (original) [Time: ");
        fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
        fout.write("]");
        fout.newLine();
   
        double dt=ct1.GetTime0()-best_time;
        fout.newLine();
        fout.write("                           *** BETTER *** [Time: ");
        fout.write("                    ");
        fout.write(CMisc.align_double(dt,5,1));
        fout.write("]");
        fout.newLine();
        fout.newLine();
        
        fout.write("                                          [      ");
        fout.write("                     ");
        double dp=dt*100/ct1.GetTime0();  
        fout.write(CMisc.align_double(dp,3,1)+"%");
        fout.write("]");
        fout.newLine();
      }  
      else
      {
        fout.write("Best combined transformation was not found!");
        fout.newLine();
      }
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    out.println("Ok");
    out.flush();
  }

  void Strategy3a(PrintWriter out,
                  CGlobal g,
                  BufferedWriter fout,
                  CProject cp,
                  CTree ctr,
                  CClient cl,
                  CTime ct1,
                  CTransformations ctrans,
                  int step1,
                  String str_prec,
                  String str_opt,
                  String str_nt)
  {
    int ret=0;

    int step=0;

    boolean transf=true;
    if (str_nt.equals("1")) transf=false;

    double prec=0;
    try
    {
      prec=Double.valueOf(str_prec).doubleValue();
    }
    catch (NumberFormatException nfe1)
    {
      prec=0;
    }

    CTime ct;

    Random rand=new Random((new Date()).getTime());

    int i=0;
    int p=0;
    int j=0;

    int nac=ctr.GetNumArraysComm();

    int step_max=15;
    int a_max   =15;        //50
    int l_t_max =15;        //128
    int l_u_max =15;        //128

    int tr=0;

    double best_time=ct1.GetTime0();
    CTime bt=new CTime();
    bt.Copy(ct1);
    int s_best=-1;

    try
    {
      for (step=1; step<=step_max; step++)
      {
        fout.write("*****************************************************************************");
        fout.newLine();
        fout.flush();

        fout.write(CMisc.align_long(step, 5));
        fout.write(")");
        fout.newLine();
        fout.newLine();

        if (step<step1)
        {
          fout.write("         OFF");
          fout.newLine();
          fout.flush();
        }
        else
        {
          boolean best_found=false;

          ctrans.RestoreQueuePosition(0);

          //Common array transformations
          if (nac!=0)
          {
            //Common array padding [random]
            fout.write("Common array padding");
            fout.newLine();
            fout.newLine();

            tr=Math.round(rand.nextFloat()*1);
            if (tr==0)
            {
              int pad=Math.round(rand.nextFloat()*a_max)+1;
              String s_pad=String.valueOf(pad);

              for (i=0; i<nac; i++)
              {
                fout.write("         array ");
                fout.write(ctr.GetNameAC(i));
                fout.write(" -> ");
                fout.write(s_pad);
                fout.newLine();
 
                if (pad>0)
                {
                  ctrans.Add(0, 0, 0, i, s_pad, "", false);
                }
              }
            }
            else
            {
              fout.write("         NO");
            }

            fout.newLine();
            fout.flush();
          }

          //Loop or Array transformations
          int np=ctr.GetNumProcs();

          for (p=0; p<np; p++)
          {
            fout.newLine();
            fout.write("Procedure: ");
            fout.write(ctr.GetProc(p));
            fout.newLine();
            fout.newLine();

            //Array transformations
            int na=ctr.GetNumArrays(p);

            if (na!=0)
            {
              tr=Math.round(rand.nextFloat()*1);
              if (tr==0)
              {
                int pad=Math.round(rand.nextFloat()*a_max)+1;
                String s_pad=String.valueOf(pad);

                for (i=0; i<na; i++)
                {
                  fout.write("         array ");
                  fout.write(ctr.GetNameA(p,i));
                  fout.write(" -> ");
                  fout.write(s_pad);
                  fout.newLine();
   
                  if (pad>0)
                  {
                    ctrans.Add(1, 0, p, i, s_pad, "", false);
                  }
                }
              }
              else
              {
                fout.write("         NO");
              }
  
              fout.newLine();
              fout.flush();
            }

            //Loop transformations
            int nl=ctr.GetNumLoops(p);

            int     best_type=0;
            int     best_i=0;
            String  best_s="";

            if (nl!=0)
            {
              String s_tile="";
              String s_unrl="";

              for (i=0; i<nl; i++)
              {
                tr=Math.round(rand.nextFloat()*1);
                if (tr==0)
                {
                  if (!ctr.GetParamL(p, i).equals("0"))
                  {
                    //loop tiling
                    j=Math.round(rand.nextFloat()*l_t_max)+2;
 
                    fout.write("         procedure: ");
                    fout.write(ctr.GetProcL(p, i));
                    fout.newLine();
  
                    fout.write("     loop variable: ");
                    fout.write(ctr.GetNameL(p, i));
                    fout.newLine();

                    fout.write("        loop index: ");
                    fout.write(ctr.GetCountL(p, i));
                    fout.newLine();

                    s_tile=String.valueOf(j);
                    fout.write("       tile factor: ");
                    fout.write(s_tile);
                    fout.newLine();

                    ctrans.Add(2, 2, p, i, s_tile, "", true);

                    fout.newLine();
                    fout.flush();
                  }
                  else
                  {
                    //loop unrolling
                    j=Math.round(rand.nextFloat()*l_u_max)+2;

                    fout.write("         procedure: ");
                    fout.write(ctr.GetProcL(p, i));
                    fout.newLine();
 
                    fout.write("     loop variable: ");
                    fout.write(ctr.GetNameL(p, i));
                    fout.newLine();

                    fout.write("        loop index: ");
                    fout.write(ctr.GetCountL(p, i));
                    fout.newLine();

                    s_unrl=String.valueOf(j);
                    fout.write("  unrolling factor: ");
                    fout.write(s_unrl);
                    fout.newLine();
 
                    ctrans.Add(2, 4, p, i, s_unrl, "", true);

                    fout.newLine();
                    fout.flush();
                  }
                }
                else
                {
                  fout.write("         NO");
                }
              }
            }
          }  

          ret=ctrans.Transform(transf, step);
          if (ret<0)
          {
            out.println(ctrans.GetLastError());
            out.flush();
            return;
          }
          else if (ret==1)
          {
            fout.write("                                          [");
            fout.write("exe was not created ...]");
            fout.newLine();
          }
          else if (ret==2)
          {
            fout.write("                                          [");
            fout.write("output is incorrect ...]");
            fout.newLine();
          }
          else if (ret==3)
          {
            fout.write("                                          [");
            fout.write("can't transform ...    ]");
            fout.newLine();
          }
          else if (ret==0)
          {
            ct=ctrans.GetTime();
            ct.Align(5,1);

            double tnew=ct.GetTime0();

            fout.write("                            (transformed) [Time: ");
            fout.write(ct.GetTimeStr1()+" + "+ct.GetTimeStr2()+" = "+ct.GetTimeStr0());
            fout.write("]");
            fout.newLine();
      
            fout.write("                                   (best) [Time: ");
            fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
            fout.write("]");
            fout.newLine();

            fout.write("                               (original) [Time: ");
            fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
            fout.write("]");
            fout.newLine();
   
            double dt=best_time-tnew;
            if (dt>=prec)
            {
              fout.newLine();
              fout.write("                           *** BETTER *** [Time: ");
              fout.write("                    ");
              fout.write(CMisc.align_double(dt,5,1));
              fout.write("]");
              fout.newLine();

              if (best_time==-1)
              {
                best_time=tnew;
                bt.Copy(ct);
                s_best=step;
                best_found=true;
              }
              else if (best_time>tnew)
              {
                best_time=tnew;
                bt.Copy(ct);
                s_best=step;
                best_found=true;
              }
            }
          }

          fout.newLine();
          fout.flush();
        }
      }

      fout.write("*****************************************************************************");
      fout.newLine();

      fout.write("Result: ");
      fout.newLine();
      fout.newLine();

      if (s_best!=-1)
      {
        fout.write("                                   (best) [Time: ");
        fout.write(bt.GetTimeStr1()+" + "+bt.GetTimeStr2()+" = "+bt.GetTimeStr0());
        fout.write("]");
        fout.newLine();

        fout.write("                               (original) [Time: ");
        fout.write(ct1.GetTimeStr1()+" + "+ct1.GetTimeStr2()+" = "+ct1.GetTimeStr0());
        fout.write("]");
        fout.newLine();
   
        double dt=ct1.GetTime0()-best_time;
        fout.newLine();
        fout.write("                           *** BETTER *** [Time: ");
        fout.write("                    ");
        fout.write(CMisc.align_double(dt,5,1));
        fout.write("]");
        fout.newLine();
        fout.newLine();
        
        fout.write("                                          [      ");
        fout.write("                     ");
        double dp=dt*100/ct1.GetTime0();  
        fout.write(CMisc.align_double(dp,3,1)+"%");
        fout.write("]");
        fout.newLine();
      }  
      else
      {
        fout.write("Best combined transformation was not found!");
        fout.newLine();
      }
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    out.println("Ok");
    out.flush();
  }

  //**************************************************************************
  void Go1(PrintWriter out,
           CGlobal g,
           BufferedWriter fout,
           String str_dir,
           String str_fp,
           String str_fo)
  {
    int ret=0;
    int i=0;

    BufferedReader fin=null;

    String str1=str_dir+str_fp;

    //Dealing with project
    CProject cp = new CProject();

    if (cp.Init(g.lng, str1, 4096)!=0)
    {
      out.println("Error (internal): Can't initialize object CProject!");
      out.flush();
      return;
    }

    if (cp.Parse()<0)
    {
      out.println(cp.GetLastError());
      out.flush();
      return;
    }
    if (cp.ParseLng()<0)
    {
      out.println(cp.GetLastError());
      out.flush();
      return;
    }

    //Start output
    try
    {
      fout.write("*****************************************************************************");
      fout.newLine();

      fout.write("Project filename : ");
      fout.write(str_fp);
      fout.newLine();

      fout.newLine();

      fout.write("Creating tree: ");

      //Create CClient for Compilation Server
      CClient cl=new CClient();
      if (cl.Init(g.cfg.GetParamStr(g.cfgCSerHost),
                  g.cfg.GetParamInt(g.cfgCSerPort),
                  8192)!=0)
      {
        out.println("Error (internal): Can't initialize object CClient!");
        out.flush();
        return;
      }

      String tree_out=fs01;
      if (!str_fo.equals("")) tree_out=str_fo;

      cl.Add("initiate compilation",      true, true);
      cl.Add("directory="+str_dir,        true, true);
      cl.Add("file_project="+str_fp,      true, true);
      cl.Add("file_diag_out="+f_tmp3,     true, true);
      cl.Add("file_out="+tree_out,        true, true);
      cl.Add("tree",                      true, true);
      cl.Add("terminate",                false, true);
    
      ret=cl.Send();
      if (ret==-1)
      {
        out.println("Error: Can't find host with Compilation Server!");
        out.flush();
        return;
      }
      else if (ret==-2)
      {
        out.println("Error: Can't connect to Compilation Server!");
        out.flush();
        return;
      }
      else if (ret==-4)
      {
        out.println("Error: Can't close connection with Compilation Server!");
        out.flush();
        return;
      }
      else if (ret<0)
      {
        out.println(cl.GetLastError());
        out.flush();
        return;
      }
   
      fout.write("Ok");
      fout.newLine();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    out.println("Ok");
    out.flush();
  }

  //**************************************************************************
  void Go2(PrintWriter out,
           CGlobal g,
           BufferedWriter fout,
           String str_dir,
           String str_fp,
           String s_opt,
           String s_opt1,
           String str_ft,
           String str_fto,
           boolean llp)
  {
    int ret=0;
    int i=0;

    String str1=str_dir+str_fp;
    String str2=str_dir+str_ft+"2";

    //Dealing with project
    CProject cp = new CProject();

    if (cp.Init(g.lng, str1, 4096)!=0)
    {
      out.println("Error (internal): Can't initialize object CProject!");
      out.flush();
      return;
    }

    if (cp.Parse()<0)
    {
      out.println(cp.GetLastError());
      out.flush();
      return;
    }
    if (cp.ParseLng()<0)
    {
      out.println(cp.GetLastError());
      out.flush();
      return;
    }

    //Dealing with tree
    CTree ctr = new CTree();

    if (ctr.Init(str2, 4096)!=0)
    {
      out.println("Error (internal): Can't initialize object CTree!");
      out.flush();
      return;
    }

    if (ctr.Parse()<0)
    {
      out.println(ctr.GetLastError());
      out.flush();
      return;
    }

    //Create CClient for Compilation Server
    CClient cl=new CClient();
    if (cl.Init(g.cfg.GetParamStr(g.cfgCSerHost),
                g.cfg.GetParamInt(g.cfgCSerPort),
                8192)!=0)
    {
      out.println("Error (internal): Can't initialize object CClient!");
      out.flush();
      return;
    }

    CTime ct=new CTime();

    CLLP cllp=new CLLP();
    cllp.Init(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile));

    //Start output
    try
    {
      fout.write("*****************************************************************************");
      fout.newLine();

      fout.write("Project filename : ");
      fout.write(str_fp);
      fout.newLine();

      fout.newLine();

      fout.write("Compiling (optimization="+s_opt+" only), running & coping output files ...");
      fout.newLine();
      fout.newLine();
      fout.write("  Compiling:     ");
      fout.flush();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    cl.Add("initiate compilation",   true, true);
    cl.Add("directory="+str_dir,     true, true);
    cl.Add("file_project="+str_fp,   true, true);
    cl.Add("file_diag_out="+f_tmp,   true, true);
    cl.Add("compilation_mode=0",     true, true);
    cl.Add("no_checking=0",          true, true);
    cl.Add("optimizations="+s_opt,   true, true);
    cl.Add("compile",                true, true);
    cl.Add("terminate",             false, true);

    ret=cl.Send();
    if (ret==-1)
    {
      out.println("Error: Can't find host with Compilation Server!");
      out.flush();
      return;
    }
    else if (ret==-2)
    {
      out.println("Error: Can't connect to Compilation Server!");
      out.flush();
      return;
    }
    else if (ret==-4)
    {
      out.println("Error: Can't close connection with Compilation Server!");
      out.flush();
      return;
    }
    else if (ret<0)
    {
      out.println(cl.GetLastError());
      out.flush();
      return;
    }

    if (llp)
    {
      cllp.Delete();
    }

    try
    {
      fout.write("Ok");
      fout.newLine();
                             
      fout.write("  Running:       ");
      fout.flush();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    cl.Add("initiate compilation",   true, true);
    cl.Add("directory="+str_dir,     true, true);
    cl.Add("file_project="+str_fp,   true, true);
    cl.Add("file_out_time="+f_tmp1,  true, true);
    cl.Add("runmode=0",              true, true);
    cl.Add("run",                    true, true);
    cl.Add("terminate",             false, true);

    ret=cl.Send();
    if (ret==-1)
    {
      out.println("Error: Can't find host with Compilation Server!");
      out.flush();
      return;
    }
    else if (ret==-2)
    {
      out.println("Error: Can't connect to Compilation Server!");
      out.flush();
      return;
    }
    else if (ret==-4)
    {
      out.println("Error: Can't close connection with Compilation Server!");
      out.flush();
      return;
    }
    else if (ret<0)
    {
      out.println(cl.GetLastError());
      out.flush();
      return;
    }

    try
    {
      fout.write("Ok");
      fout.newLine();
      fout.flush();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }
     
    //Get time
    if (ct.Init(str_dir+f_tmp1)<0)
    {
      out.println(ct.GetLastError());
      out.flush();
      return;
    }

    ct.Align(5,1);

    try
    {
      fout.write("                                          [Time: ");
      fout.write(ct.GetTimeStr1());
      fout.write(" + ");      
      fout.write(ct.GetTimeStr2());
      fout.write(" = ");
      fout.write(ct.GetTimeStr0());
      fout.write("]");
      fout.newLine();
      fout.newLine();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    //Writing time
    BufferedWriter fout1=null;

    try
    {
      fout1=new BufferedWriter(new FileWriter(str_dir+str_fto));
    }
    catch (IOException e1)
    {
      out.println("Error: Can't open file for writing time!");
      out.flush();
      return;
    }

    try
    {
      fout1.write(ct.GetTimeStr0().trim());
      fout1.newLine();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    try
    {
      fout1.close();
    }
    catch (Exception e5)
    {}

    if (llp)
    {
      try
      {
        fout.write("");
        fout.write("  Analyzing LLP: ");
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }

      ret=cllp.Parse();
      try
      {
        if (ret==-1)
        {
          fout.newLine();
          fout.write("Error: Can't find file with LLP!");
          fout.newLine();
          fout.flush();
        }
        else if (ret==-2)
        {
          fout.newLine();
          fout.write("Error: Can't parse LLP file!");
          fout.newLine();
          fout.flush();
        }
        else if (ret==-3)
        {
          fout.newLine();
          fout.write("Error: Can't close LLP file!");
          fout.newLine();
          fout.flush();
        }
        else if (ret<0)
        {
          fout.newLine();
          fout.write(cl.GetLastError());
          fout.newLine();
          fout.flush();
        }
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }
    }

    if (ret==0)
    {
      try
      {
        fout.write("Ok");
        fout.newLine();

        int nl=cllp.GetNumberOfTimers();
 
        fout.write("=======================================");
        fout.newLine();
        for (int ii=0; ii<nl; ii++)
        {
          fout.write(cllp.PrintLine(ii));
          fout.newLine();
        }
        fout.write("=======================================");
        fout.newLine();

        ret=cllp.Copy("_p1");
        if (ret<0)
        {
          fout.newLine();
          fout.write(cl.GetLastError());
          fout.newLine();
          fout.flush();
        }
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }
    }

    //Create project with choosen files
    int np=ctr.GetNumProcs();
    if (np==0)
    {
      try
      {
        fout.newLine();
        fout.write("Error: No selected arrays or loops in tree file!");
        fout.newLine();
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }

      out.println("Ok");
      out.flush();

      return;
    }

    //instead of 8192 it's better to check the real amount
    //but didn't have time to do it...
    String[] fn=new String [np+8192];

    int np1=0;
    fn[np1]=ctr.GetFileName(np1);

    np1++;
    for (i=1; i<np; i++)
    {
      boolean found=false;
      for (int j=0; j<np1; j++)
      {
        if (fn[j].equals(ctr.GetFileName(i)))
        {
          found=true;
          break;
        }
      }
      if (!found) fn[np1++]=ctr.GetFileName(i);
    }

    //check all common arrays inside other procedures
    int nac=ctr.GetNumArraysComm();
    if (nac!=0)
    {
      for (i=0; i<nac; i++)
      {
        String name1=ctr.GetNameAC(i);

        for (int j=0; j<ctr.GetNumArraysCommAll(); j++)
        {
          String file1q=ctr.GetFileACAll(j);
          String name1q=ctr.GetNameACAll(j);

          if (name1q.equals(name1))
          {
            boolean found=false;
            for (int k=0; k<np1; k++)
            {
              if (fn[k].equals(file1q))
              {
                found=true;
                break;
              }
            }
            if (!found)
            {
              fn[np1++]=file1q;
            }
          }
        }
      }
    }

    String f_prj1=str_dir+f_tmp_prj;
    String f_prj2=str_dir+f_tmp_prj2;
         
    CProject cp_new = new CProject();
    cp_new.Init(cp, f_prj1);

    CProject cp_new2 = new CProject();
    cp_new2.Init(cp, f_prj2);
  
    for (i=0; i<np1; i++)
    {
      boolean found=false;

      int j=0;

      for (j=0; j<cp.GetNumFiles(); j++)
      {
        if (fn[i].equals(cp.GetFileName(j)+cp.GetFileExt(j)))
        {
          found=true;
          break;
        }
      }

      if (!found)
      {
        out.println("Error: Inconsistencies in new project file!");
        out.flush();
        return;
      }
      else
      {
        cp_new.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j),
                        cp.GetFileExt(j), cp.GetExtraOpt(j));

        cp_new2.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j)+f_prs,
                         cp.GetFileExt(j), cp.GetExtraOpt(j));
      }
    }

    if (cp_new.Save()<0)
    {
      try
      {
        fout.write("Error: Can't save new project!");
        fout.newLine();
        fout.flush();
        return;
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }
    }

    if (cp_new2.Save()<0)
    {
      try
      {
        fout.write("Error: Can't save new project2!");
        fout.newLine();
        fout.flush();
        return;
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }
    }

    //Remove original object files
    cl.Add("initiate compilation",     true, true);
    cl.Add("directory="+str_dir,       true, true);
    cl.Add("file_project="+f_tmp_prj,  true, true);
    cl.Add("remove_obj",               true, true);
    cl.Add("terminate",               false, true);

    ret=cl.Send();
    if (ret==-1)
    {
      out.println("Error: Can't find host with Compilation Server!");
      out.flush();
      return;
    }
    else if (ret==-2)
    {
      out.println("Error: Can't connect to Compilation Server!");
      out.flush();
      return;
    }
    else if (ret==-4)
    {
      out.println("Error: Can't close connection with Compilation Server!");
      out.flush();
      return;
    }
    else if (ret<0)
    {
      out.println(cl.GetLastError());
      out.flush();
      return;
    }

    //Parse
    try
    {
      fout.write("  Parsing:       ");
      fout.flush();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    //Preparing Client for Transformations (Main Language)
    int mainLng=cp.GetLng(0);

    //Create CClient for Transformation Server
    if (g.lng.GetConfig(mainLng).GetParamStr(g.lngTSerHost).equals(""))
    {
      out.println("Error: Main language in project file is not supported by Transformation Server!");
      out.flush();
      return;
    }

    CClient cl1=new CClient();
    if (cl1.Init(g.lng.GetConfig(mainLng).GetParamStr(g.lngTSerHost),
                 g.lng.GetConfig(mainLng).GetParamInt(g.lngTSerPort),
                 8192)!=0)
    {
      out.println("Error (internal): Can't initialize object CClient!");
      out.flush();
      return;
    }

    for (i=1; i<cp_new.GetNumFiles(); i++)
    {
      //Next line (delay) was added on 2002.10.07
      //to work properly with transformation server
      //if it restarts
      try
      {
        Thread.currentThread().sleep(100);
      }
      catch (InterruptedException e)
      {}

      //Build list of transformation
      String q1=cp_new.GetFileName(i)+cp_new.GetFileExt(i);
      String q2=cp_new2.GetFileName(i)+cp_new2.GetFileExt(i);

      cl1.Add("initiate transformations",  true, true);
      cl1.Add("filein="+str_dir+q1,        true, true);
      cl1.Add("fileout="+str_dir+q2,       true, true);
      cl1.Add("fileouterror="+f_tmp2,      true, true);
      cl1.Add("parse",                     true, true);
      cl1.Add("terminate",                false, true);

      ret=cl1.Send();
      if (ret==-1)
      {
        out.println("Error: Can't find host with Transformation Server!");
        out.flush();
        return;
      }
      else if (ret==-2)
      {
        out.println("Error: Can't connect to Transformation Server!");
        out.flush();
        return;
      }
      else if (ret==-4)
      {
        out.println("Error: Can't close connection with Transformation Server!");
        out.flush();
        return;
      }
      else if (ret<0)
      {
        out.println(cl1.GetLastError());
        out.flush();
        return;
      }
    }

    try
    {
      fout.write("Ok");
      fout.newLine();
      fout.newLine();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    if (!s_opt1.equals("0"))
    {
      //Compile new object files with linking
      //but without error if file was not created
      try
      {
        fout.write("Compiling (optimization="+s_opt+" & "+s_opt1+"), running & coping output files ...");
        fout.newLine();
        fout.newLine();
        fout.write("  Compiling:     ");
        fout.flush();
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }

      cl.Add("initiate compilation",     true, true);
      cl.Add("directory="+str_dir,       true, true);
      cl.Add("file_project="+f_tmp_prj2, true, true);
      cl.Add("file_diag_out="+f_tmp,     true, true);
      cl.Add("compilation_mode=1",       true, true);
      cl.Add("no_checking=1",            true, true);
      cl.Add("optimizations="+s_opt1,    true, true);
      cl.Add("compile",                  true, true);
      cl.Add("terminate",               false, true);

      ret=cl.Send();
      if (ret==-1)
      {
        out.println("Error: Can't find host with Compilation Server!");
        out.flush();
        return;
      }
      else if (ret==-2)
      {
        out.println("Error: Can't connect to Compilation Server!");
        out.flush();
        return;
      }
      else if (ret==-4)
      {
        out.println("Error: Can't close connection with Compilation Server!");
        out.flush();
        return;
      }
      else if (ret<0)
      {
        out.println(cl.GetLastError());
        out.flush();
        return;
      }

      //Check here if file was created or not 
      boolean created=true;
      boolean correct=false;

      String x1=str_dir+cp_new.GetExe();

      FileInputStream fin1=null;

      try
      {
        fin1=new FileInputStream(x1);
      }
      catch (FileNotFoundException e1)
      {
        created=false;
      }

      try
      {
        fin1.close();
      }
      catch (Exception e4)
      {}
     
      if (!created)
      {
        try
        {
          fout.write("Exe file was not created!");
          fout.newLine();
        }
        catch (Exception e2)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }
      }
      else
      {
        try
        {
          fout.write("Ok");
          fout.newLine();
                              
          fout.write("  Running:       ");
          fout.flush();
        }
        catch (Exception e2)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }

        if (llp)
        {
          cllp.Delete();
        }

        //Run transformed application
        cl.Add("initiate compilation",     true, true);
        cl.Add("directory="+str_dir,       true, true);
        cl.Add("file_project="+f_tmp_prj2, true, true);
        cl.Add("file_out_time="+f_tmp1,    true, true);
        cl.Add("file_out_comp="+f_tmp2,    true, true);
        cl.Add("runmode=1",                true, true);
        cl.Add("run",                      true, true);
        cl.Add("terminate",               false, true);

        ret=cl.Send();
        if (ret==-1)
        {
          out.println("Error: Can't find host with Compilation Server!");
          out.flush();
          return;
        }
        else if (ret==-2)
        {
          out.println("Error: Can't connect to Compilation Server!");
          out.flush();
          return;
        }
        else if (ret==-4)
        {
          out.println("Error: Can't close connection with Compilation Server!");
          out.flush();
          return;
        }
        else if (ret<0)
        {
          out.println(cl.GetLastError());
          out.flush();
          return;
        }
 
        try
        {
          if (CMisc.isCorrect(str_dir+f_tmp2)==1)
          {
            fout.write("Ok");
            fout.newLine();
            fout.flush();
          }
          else
          {
            fout.write("The output is different!");
            fout.newLine();
            fout.flush();
          }
        }
        catch (Exception e2)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }

        //Get time
        if (ct.Init(str_dir+f_tmp1)<0)
        {
          out.println(ct.GetLastError());
          out.flush();
          return;
        }

        ct.Align(5,1);

        try
        {
          fout.write("                                          [Time: ");
          fout.write(ct.GetTimeStr1());
          fout.write(" + ");      
          fout.write(ct.GetTimeStr2());
          fout.write(" = ");
          fout.write(ct.GetTimeStr0());
          fout.write("]");
          fout.newLine();
          fout.newLine();
        }
        catch (Exception e2)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }
      }

      try
      {
        fout1=new BufferedWriter(new FileWriter(str_dir+str_fto, true));
      }
      catch (IOException e1)
      {
        out.println("Error: Can't open file for writing time!");
        out.flush();
        return;
      }

      try
      {
        fout1.write(ct.GetTimeStr0().trim());
        fout1.newLine();
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }

      try
      {
        fout1.close();
      }
      catch (Exception e5)
      {}

      if (llp)
      {
        try
        {
          fout.write("");
          fout.write("  Analyzing LLP: ");
        }
        catch (Exception e2)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }

        ret=cllp.Parse();
        try
        {
          if (ret==-1)
          {
            fout.newLine();
            fout.write("Error: Can't find file with LLP!");
            fout.newLine();
            fout.flush();
          }
          else if (ret==-2)
          {
            fout.newLine();
            fout.write("Error: Can't parse LLP file!");
            fout.newLine();
            fout.flush();
          }
          else if (ret==-3)
          {
            fout.newLine();
            fout.write("Error: Can't close LLP file!");
            fout.newLine();
            fout.flush();
          }
          else if (ret<0)
          {
            fout.newLine();
            fout.write(cl.GetLastError());
            fout.newLine();
            fout.flush();
          }
        }
        catch (Exception e2)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }
      }

      if (ret==0)
      {
        try
        {
          fout.write("Ok");
          fout.newLine();

          int nl=cllp.GetNumberOfTimers();
 
          fout.write("=============================================");
          fout.newLine();
          for (int ii=0; ii<nl; ii++)
          {
            fout.write(cllp.PrintLine(ii));
            fout.newLine();
          }
          fout.write("=============================================");
          fout.newLine();

          ret=cllp.Copy("_p2");
          if (ret<0)
          {
            fout.newLine();
            fout.write(cl.GetLastError());
            fout.newLine();
            fout.flush();
          }
        }
        catch (Exception e2)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }
      }
    }

    out.println("Ok");
    out.flush();
  }

  //**************************************************************************
  void Go3(PrintWriter out,
           CGlobal g,
           BufferedWriter fout,
           String str_dir,
           String str_fp,
           String str_ft,
           String str_strat,
           String str_prec,
           String str_opt,
           String str_opt1,
           String str_rt,
           String str_fto,
           String str_step,
           String str_pt1,
           String str_pt2,
           String str_pt3,
           String str_pu1,
           String str_pu2,
           String str_pu3,
           String str_pp1,
           String str_pp2,
           String str_pp3,
           String str_grid,
           String str_rnd,
           String str_iio,
           String str_sfb,
           String str_fpo,
           String str_fio,
           String str_fti,
           String str_apo,
           String str_cdes,
           boolean llp,
           String str_dir_ic,
           String str_noe)
  {
    int ret=0;
    int i=0;

    int step=0;

    int pt1=0;
    int pt2=0;
    int pt3=0;
    int pu1=0;
    int pu2=0;
    int pu3=0;
    int pp1=0;
    int pp2=0;
    int pp3=0;
    int pg=0;
    int pr=0;

    boolean apo=false;
    boolean cdes=false;

    if (str_apo.equals("1")) apo=true;
    if (str_cdes.equals("1")) cdes=true;

    if (!str_pt1.equals(""))
    {
      try
      {
        pt1=Integer.valueOf(str_pt1).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pt2.equals(""))
    {
      try
      {
        pt2=Integer.valueOf(str_pt2).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pt3.equals(""))
    {
      try
      {
        pt3=Integer.valueOf(str_pt3).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pu1.equals(""))
    {
      try
      {
        pu1=Integer.valueOf(str_pu1).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pu2.equals(""))
    {
      try
      {
        pu2=Integer.valueOf(str_pu2).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pu3.equals(""))
    {
      try
      {
        pu3=Integer.valueOf(str_pu3).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pp1.equals(""))
    {
      try
      {
        pp1=Integer.valueOf(str_pp1).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pp2.equals(""))
    {
      try
      {
        pp2=Integer.valueOf(str_pp2).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pp3.equals(""))
    {
      try
      {
        pp3=Integer.valueOf(str_pp3).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_grid.equals(""))
    {
      try
      {
        pg=Integer.valueOf(str_grid).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_rnd.equals(""))
    {
      try
      {
        pr=Integer.valueOf(str_rnd).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }

    boolean once=false;
    if (!str_step.equals("") && !str_step.equals("0"))
    {
      step=0;
      try
      {
        step=Integer.valueOf(str_step).intValue();
      }
      catch (NumberFormatException nfe2)
      {}

      once=true;
    }

    if (pt1==0) pt1=2;
    if (pt2==0) pt2=20;
    if (pt3==0) pt3=1;
    if (pu1==0) pu1=2;
    if (pu2==0) pu2=20;
    if (pu3==0) pu3=1;
    if (pp1==0) pp1=1;
    if (pp2==0) pp2=20;
    if (pp3==0) pp3=1;
    if (pg ==0) pg =3;
    if (pr ==0) pr =3;

    if (step>0) step--;

    int stepz=step;

    String str="";

    String str1=str_dir+str_fp;
    String str2=str_dir+str_ft+"2";
    String str3=str_dir+str_fti;
    String str4=str_dir+str_fto;
    String str5=str_dir+str_fto+"_tmp";

    if (str_sfb.equals("1") && !once)
    {
      //Delete time file if exist
      File fdel=null;
      try
      {
        fdel=new File(str4);
        fdel.delete();
      }
      catch (NullPointerException e1)
      {}
    }

    boolean nonzerostep=false;

    BufferedReader fin9=null;

    //Dealing with project
    CProject cp = new CProject();

    if (cp.Init(g.lng, str1, 4096)!=0)
    {
      out.println("Error (internal): Can't initialize object CProject!");
      out.flush();
      return;
    }

    if (cp.Parse()<0)
    {
      out.println(cp.GetLastError());
      out.flush();
      return;
    }
    if (cp.ParseLng()<0)
    {
      out.println(cp.GetLastError());
      out.flush();
      return;
    }

    //Create CClient for Compilation Server
    CClient cl=new CClient();
    if (cl.Init(g.cfg.GetParamStr(g.cfgCSerHost),
                g.cfg.GetParamInt(g.cfgCSerPort),
                8192)!=0)
    {
      out.println("Error (internal): Can't initialize object CClient!");
      out.flush();
      return;
    }

    //Dealing with tree
    CTree ctr = new CTree();

    if (ctr.Init(str2, 4096)!=0)
    {
      out.println("Error (internal): Can't initialize object CTree!");
      out.flush();
      return;
    }

    if (ctr.Parse()<0)
    {
      out.println(ctr.GetLastError());
      out.flush();
      return;
    }

    CTime ct=new CTime();
    CTime ct9=new CTime();

    CLLP cllp=new CLLP();
    cllp.Init(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile));
    CLLP cllp1=new CLLP();
    cllp1.Init(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile)+"_p1");
    CLLP cllp2=new CLLP();
    if (!str_opt1.equals("0"))
    {
      cllp2.Init(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile)+"_p2");
    }
    else
    {
      cllp2.Init(str_dir+g.cfg.GetParamStr(g.cfgLLPProfFile)+"_p1");
    }

    //Start output
    try
    {
      fout.write("*****************************************************************************");
      fout.newLine();

      fout.write("Project filename : ");
      fout.write(str_fp);
      fout.newLine();
      fout.write("Directory        : ");
      fout.write(str_dir);
      fout.newLine();
      fout.write("Input tree file  : ");
      fout.write(str_ft);
      fout.newLine();
      fout.write("Strategy         : ");
      fout.write(str_strat);
      fout.newLine();
      fout.write("Optimization     : ");
      fout.write(str_opt);
      fout.newLine();
      fout.write("Optimization1    : ");
      fout.write(str_opt1);
      fout.newLine();
      fout.write("Precision        : ");
      fout.write(str_prec);
      fout.newLine();

      fout.write("*****************************************************************************");
      fout.newLine();

      fout.write("Array Pad Start     : "+String.valueOf(pp1));
      fout.newLine();                
      fout.write("Array Pad End       : "+String.valueOf(pp2));
      fout.newLine();               
      fout.write("Array Pad Step      : "+String.valueOf(pp3));
      fout.newLine();
      fout.write("Loop Tile Start     : "+String.valueOf(pt1));
      fout.newLine();
      fout.write("Loop Tile End       : "+String.valueOf(pt2));
      fout.newLine();
      fout.write("Loop Tile Step      : "+String.valueOf(pt3));
      fout.newLine();
      fout.write("Loop Unroll Start   : "+String.valueOf(pu1));
      fout.newLine();
      fout.write("Loop Unroll End     : "+String.valueOf(pu2));
      fout.newLine();
      fout.write("Loop Unroll Step    : "+String.valueOf(pu3));
      fout.newLine();
      fout.write("Grid Parameter      : "+String.valueOf(pg));
      fout.newLine();
      fout.write("RND Parameter       : "+String.valueOf(pr));
      fout.newLine();
      fout.write("Number of executions: "+str_noe);
      fout.newLine();

      fout.write("*****************************************************************************");
      fout.newLine();
      fout.flush();
      
      if (ctr.GetNumProcs()==0)
      {
        fout.write("Error: No selected arrays or loops in tree file!");
        fout.newLine();
      }
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    try
    {
      fout.write("Reading file with time: ");
      fout.flush();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    //Reading file with original time
    if (CMisc.isFileExist(str3))
    {
      BufferedReader fin=null;
 
      try
      {
        fin=new BufferedReader(new FileReader(str3));
      }
      catch (IOException e2)
      {
        try
        {
          fout.write("Error: Can't find file with time!");
          fout.newLine();
          fout.flush();
        }
        catch (Exception e2x)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }

        return;
      }

      try
      {
        str=fin.readLine();
        ct.Init1(str, "");
        if (!str_opt1.equals("0"))
        {
          str=fin.readLine();
        }
        ct9.Init1(str, "");
      }
      catch (Exception e1)
      {
        try
        {
          fin.close();
        }
        catch (Exception e2)
        {}
        try
        {
          fout.write("Error: Problems reading file with time!");
          fout.newLine();
          fout.flush();
        }
        catch (Exception e2)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }
        return;
      }
 
      try
      {
        fin.close();
      }
      catch (Exception e3)
      {}

      try
      {
        fout.write("Ok");
        fout.newLine();
        fout.flush();
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }
    }
    else
    {
      try
      {
        fout.write("Error - can't find file with time!");
        fout.newLine();
        fout.flush();
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }
    }
  
    ct.Align(5,1);
    ct9.Align(5,1);

    try
    {
      fout.newLine();
      fout.write("                                         [TimeA: ");
      fout.write(ct.GetTimeStr1());
      fout.write(" + ");      
      fout.write(ct.GetTimeStr2());
      fout.write(" = ");
      fout.write(ct.GetTimeStr0());
      fout.write("]");
      fout.newLine();
      fout.newLine();

      if (!str_opt1.equals("0"))
      {
        fout.newLine();
        fout.write("                                         [TimeB: ");
        fout.write(ct9.GetTimeStr1());
        fout.write(" + ");      
        fout.write(ct9.GetTimeStr2());
        fout.write(" = ");
        fout.write(ct9.GetTimeStr0());
        fout.write("]");
        fout.newLine();
        fout.newLine();
      }
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    if (llp)
    {
      try
      {
        fout.write("Reading file with LLP : ");
        fout.flush();
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }

      ret=cllp1.Parse();
      int ret1=ret;
      try
      {
        if (ret==-1)
        {
          fout.newLine();
          fout.write("Error: Can't find file with LLP!");
          fout.newLine();
          fout.flush();
        }
        else if (ret==-2)
        {
          fout.newLine();
          fout.write("Error: Can't parse LLP file!");
          fout.newLine();
          fout.flush();
        }
        else if (ret==-3)
        {
          fout.newLine();
          fout.write("Error: Can't close LLP file!");
          fout.newLine();
          fout.flush();
        }
        else if (ret<0)
        {
          fout.newLine();
          fout.write(cl.GetLastError());
          fout.newLine();
          fout.flush();
        }
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }
    
      ret=cllp2.Parse();
      int ret2=ret;
      try
      {
        if (ret==-1)
        {
          fout.newLine();
          fout.write("Error: Can't find file with LLP!");
          fout.newLine();
          fout.flush();
        }
        else if (ret==-2)
        {
          fout.newLine();
          fout.write("Error: Can't parse LLP file!");
          fout.newLine();
          fout.flush();
        }
        else if (ret==-3)
        {
          fout.newLine();
          fout.write("Error: Can't close LLP file!");
          fout.newLine();
          fout.flush();
        }
        else if (ret<0)
        {
          fout.newLine();
          fout.write(cl.GetLastError());
          fout.newLine();
          fout.flush();
        }  
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }

      if (ret1<0 || ret2<0)
      {
        try
        {
          fout.write("Error - can't find process files with LLP!");
          fout.newLine();
          fout.flush();
        }
        catch (Exception e2)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }

        out.println("Ok");
        out.flush();
        return;
      }

      try
      {
        fout.write("Ok");
        fout.newLine();

        int nl=cllp1.GetNumberOfTimers();
 
        fout.write("====================================================================================================================");
        fout.newLine();
        for (int ij=0; ij<nl; ij++)
        {
          fout.write(" OPT1={"+cllp1.PrintLine(ij)+" }");
          if (!str_opt1.equals("0"))
          {
            fout.write(",  OPT2={"+cllp2.PrintLine(ij)+" } ");
          }
          fout.newLine();
        }
        fout.write("====================================================================================================================");
        fout.newLine();
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }
    }

    //Reading file with steps (time for each step)
    step=0;

    if (CMisc.isFileExist(str4))
    {
      BufferedReader fin=null;

      try
      {
        fin=new BufferedReader(new FileReader(str4));
      }
      catch (IOException e2)
      {
        try
        {
          fout.write("Error: Can't find file with time!");
          fout.newLine();
          fout.flush();
        }
        catch (Exception e2x)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }
 
        return;
      }

      try
      {
        boolean stop=false;
  
        while ((str=fin.readLine())!=null && !stop)
        {
          int ind1=str.indexOf("'");
          int ind2=str.indexOf("'", ind1+1);
  
          if ((ind1!=-1) && (ind2!=-1))
          {
            ind1=str.indexOf("'", ind2+1);
            ind2=str.indexOf("'", ind1+1);
   
            if ((ind1!=-1) && (ind2!=-1))
            {
              ind1=str.indexOf("'", ind2+1);
              ind2=str.indexOf("'", ind1+1);
 
              if ((ind1!=-1) && (ind2!=-1))
              {
                step++;
              }
              else stop=true;
            }
            else stop=true;
          }
          else stop=true;
        }
      }
      catch (Exception e1)
      {
        try
        {
          fin.close();
        }
        catch (Exception e2)
        {}

        try
        {
          fout.write("Error: Problems reading file with time!");
          fout.newLine();
          fout.flush();
        }
        catch (Exception e2)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }
        return;
      }
 
      try
      {
        fin.close();
      }
      catch (Exception e3)
      {}
      
      if (!once)
      {
        if (step!=0)
        {
          nonzerostep=true;

          try
          {
            fout.newLine();
            fout.newLine();
            fout.write("Starting from step "+String.valueOf(step)+" ...");
            fout.newLine();
            fout.newLine();
          }
          catch (Exception e2)
          {
            out.println("Error: Problems while writing diagnostic files!");
            out.flush();
            return;
          }
        }
      }

      //copy file ..
      CMisc.CopyTextFile(str4, str5);

      try
      {
        fin9=new BufferedReader(new FileReader(str5));
      }
      catch (IOException e2)
      {
        try
        {
          fout.write("Error: Can't find file with time (1)!");
          fout.newLine();
          fout.flush();
        }
        catch (Exception e2x)
        {
          out.println("Error: Problems while writing diagnostic files!");
          out.flush();
          return;
        }

        return;
      }
    }

    if (once) step=stepz;

    boolean ignore_incorrect_out=false;
    if (str_iio.equals("1")) ignore_incorrect_out=true;

    //Initializing CTransformations
    CTransformations1 ctrans=new CTransformations1();
    if (ctrans.Init(8192, ctr, cl, cp, g,
                    str_dir, str_fp, f_tmp, 
                    str_opt1, str_rt, str_opt, ct9,
                    ignore_incorrect_out, str_fpo, str_fio,
                    str_dir_ic, str_noe)<0)
    {
      out.println(ctrans.GetLastError());
      out.flush();
      return;
    }

    //Choosing search strategy
    if (str_strat.equals("1a"))
    {
      Strategies_Search1a.Search1a(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3, 
                                   apo, cdes, str_dir);
    }
    else if (str_strat.equals("1b"))
    {
      Strategies_Search1b.Search1b(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   apo, cdes, str_dir);
    }
    else if (str_strat.equals("1c"))
    {
      Strategies_Search1c.Search1c(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   apo, cdes, str_dir);
    }
    else if (str_strat.equals("2a"))
    {
      Strategies_Search2a.Search2a(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   apo, cdes, str_dir);
    }
    else if (str_strat.equals("2b"))
    {
      Strategies_Search2b.Search2b(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   apo, cdes, str_dir);
    }
    else if (str_strat.equals("2c"))
    {
      Strategies_Search2c.Search2c(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   apo, cdes, str_dir);
    }
    else if (str_strat.equals("3a"))
    {
      Strategies_Search3a.Search3a(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("3c"))
    {
      Strategies_Search3c.Search3c(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("4a"))
    {
      Strategies_Search4a.Search4a(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("4c"))
    {
      Strategies_Search4c.Search4c(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("5a"))
    {
      Strategies_Search5a.Search5a(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("5c"))
    {
      Strategies_Search5c.Search5c(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("6a"))
    {
      Strategies_Search6a.Search6a(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("6c"))
    {
      Strategies_Search6c.Search6c(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("7a"))
    {
      Strategies_Search7a.Search7a(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("7c"))
    {
      Strategies_Search7c.Search7c(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("8a"))
    {
      Strategies_Search8a.Search8a(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("8c"))
    {
      Strategies_Search8c.Search8c(out, g, fout,
                                   cp, ctr, cl, ct, ct9, ctrans,
                                   step, str_prec, str_opt, 
                                   str4, str5, fin9, once,
                                   pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                   pg, pr, apo, cdes, str_dir);
    }
    else if (str_strat.equals("11c"))
    {
      Strategies_Search11c.Search11c(out, g, fout,
                                     cp, ctr, cl, ct, ct9, ctrans,
                                     step, str_prec, str_opt, 
                                     str4, str5, fin9, once,
                                     pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                     apo, cdes, str_dir, cllp, cllp1, cllp2, 
                                     str_opt1, str_fp, str_dir_ic);
    }
    else if (str_strat.equals("12c"))
    {
      Strategies_Search12c.Search12c(out, g, fout,
                                     cp, ctr, cl, ct, ct9, ctrans,
                                     step, str_prec, str_opt, 
                                     str4, str5, fin9, once,
                                     pt1, pt2, pt3, pu1, pu2, pu3, pp1, pp2, pp3,
                                     apo, cdes, str_dir, cllp, cllp1, cllp2, 
                                     str_opt1, str_fp, str_dir_ic);
    }
    else
    {
      try
      {
        fout.write("Error: Unknown strategy!");
        fout.newLine();
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }
    }

    if (nonzerostep && !once)
    {
      nonzerostep=false;
      
      try
      {
        fin9.close();
      }
      catch (Exception e2)
      {}
    }

    try
    {
      fout.write("*****************************************************************************");
      fout.newLine();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    out.println("Ok");
    out.flush();
  }

  //**************************************************************************
  void Go4(PrintWriter out,
           CGlobal g,
           String str_dir,
           String str_fdo,
           String str_fto)
  {
    String str="";

    String str1=str_dir+str_fdo;
    String str2=str_dir+str_fto;

    BufferedReader fin=null;
    BufferedWriter fout=null;

    try
    {
      fin =new BufferedReader(new FileReader(str1));
      fout=new BufferedWriter(new FileWriter(str2));
    }
    catch (IOException e2)
    {
      out.println("Error: Problems while opening files!");
      out.flush();
      return;
    }

    try
    {
      boolean stop=false;
      boolean found=false;
      while (!stop && (found || ((str=fin.readLine())!=null)))
      {
        if ((str.length()>=5) && (str.charAt(5)==')'))
        {
          String stp=str.substring(0,5).trim();

          String time="99999.9";
          String ret="1";

          boolean finish=false;
          while (!finish && ((str=fin.readLine())!=null))
          {
            if (str.indexOf("(transformed)")!=-1)
            {
              int ind1=str.indexOf("=");
              int ind2=str.indexOf("]", ind1+1);

              if ((ind1!=-1) && (ind2!=-1))
              {
                time=str.substring(ind1+1, ind2);
              }

              ret="0";
            }
            else if ((str.length()>=5) && (str.charAt(5)==')'))
            {
              finish=true;
              found=true;
            }
          }

          if (str==null) stop=true;

          fout.write("'"+stp+"', '"+time+"', '"+ret+"'");
          fout.newLine();
        }
      }
    }
    catch (Exception e1)
    {
      try
      {
        fin.close();
        fout.close();
      }
      catch (Exception e2)
      {}

      out.println("Error: Problems while working with files!");
      out.flush();
      return;
    }
 
    try
    {
      fin.close();
      fout.close();
    }
    catch (Exception e3)
    {}

    out.println("Ok");
    out.flush();
  }

  //**************************************************************************
  void Go5(PrintWriter out,
           CGlobal g,
           BufferedWriter fout,
           String str_dir,
           String str_ft,
           String str_strat,
           String str_pt1,
           String str_pt2,
           String str_pt3,
           String str_pu1,
           String str_pu2,
           String str_pu3,
           String str_pp1,
           String str_pp2,
           String str_pp3,
           String str_grid,
           String str_rnd)
  {
    long num_of_iter=0;

    int i,j,k,p;

    int pt1=0;
    int pt2=0;
    int pt3=0;
    int pu1=0;
    int pu2=0;
    int pu3=0;
    int pp1=0;
    int pp2=0;
    int pp3=0;
    int pg=0;
    int pr=0;

    if (!str_pt1.equals(""))
    {
      try
      {
        pt1=Integer.valueOf(str_pt1).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pt2.equals(""))
    {
      try
      {
        pt2=Integer.valueOf(str_pt2).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pt3.equals(""))
    {
      try
      {
        pt3=Integer.valueOf(str_pt3).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pu1.equals(""))
    {
      try
      {
        pu1=Integer.valueOf(str_pu1).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pu2.equals(""))
    {
      try
      {
        pu2=Integer.valueOf(str_pu2).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pu3.equals(""))
    {
      try
      {
        pu3=Integer.valueOf(str_pu3).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pp1.equals(""))
    {
      try
      {
        pp1=Integer.valueOf(str_pp1).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pp2.equals(""))
    {
      try
      {
        pp2=Integer.valueOf(str_pp2).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_pp3.equals(""))
    {
      try
      {
        pp3=Integer.valueOf(str_pp3).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_grid.equals(""))
    {
      try
      {
        pg=Integer.valueOf(str_grid).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }
    if (!str_rnd.equals(""))
    {
      try
      {
        pr=Integer.valueOf(str_rnd).intValue();
      }
      catch (NumberFormatException nfe2)
      {}
    }

    //Dealing with tree
    String str2=str_dir+str_ft+"2";

    CTree ctr = new CTree();

    if (ctr.Init(str2, 4096)!=0)
    {
      out.println("Error (internal): Can't initialize object CTree!");
      out.flush();
      return;
    }

    if (ctr.Parse()<0)
    {
      out.println(ctr.GetLastError());
      out.flush();
      return;
    }

    try
    {
      fout.write("*****************************************************************************");
      fout.newLine();

      fout.write("Directory        : ");
      fout.write(str_dir);
      fout.newLine();
      fout.write("Input tree file  : ");
      fout.write(str_ft);
      fout.newLine();
      fout.write("Strategy         : ");
      fout.write(str_strat);
      fout.newLine();

      fout.write("*****************************************************************************");
      fout.newLine();

      fout.newLine();
      fout.write("Array Pad Start  : "+String.valueOf(pp1));
      fout.newLine();
      fout.write("Array Pad End    : "+String.valueOf(pp2));
      fout.newLine();
      fout.write("Array Pad Step   : "+String.valueOf(pp3));
      fout.newLine();
      fout.write("Loop Tile Start  : "+String.valueOf(pt1));
      fout.newLine();
      fout.write("Loop Tile End    : "+String.valueOf(pt2));
      fout.newLine();
      fout.write("Loop Tile Step   : "+String.valueOf(pt3));
      fout.newLine();
      fout.write("Loop Unroll Start: "+String.valueOf(pu1));
      fout.newLine();
      fout.write("Loop Unroll End  : "+String.valueOf(pu2));
      fout.newLine();
      fout.write("Loop Unroll Step : "+String.valueOf(pu3));
      fout.newLine();

      fout.flush();
      
      if (ctr.GetNumProcs()==0)
      {
        fout.write("Error: No selected arrays or loops in tree file!");
        fout.newLine();
      }
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    //Choosing search strategy
    if (str_strat.equals("1a") ||
        str_strat.equals("1b") ||
        str_strat.equals("2a") ||
        str_strat.equals("2b"))
    {
      int nac=ctr.GetNumArraysComm();

      if (nac!=0)
      {
        for (i=0; i<nac; i++)
        {
          //common array padding
          for (j=pp1; j<=pp2; j+=pp3)
          {
            num_of_iter++;
          }
        }
      }

      int np=ctr.GetNumProcs();

      //non-common array transformations
      for (p=0; p<np; p++)
      {
        //Array transformations
        int na=ctr.GetNumArrays(p);

        if (na==0)
        {
        }
        else 
        {
          for (i=0; i<na; i++)
          {
            for (j=pp1; j<=pp2; j+=pp3)
            {
              num_of_iter++;
            }
          }
        }
      }

      //loop transformations
      for (p=0; p<np; p++)
      {
        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
              //loop tiling
              for (j=pt1; j<=pt2; j+=pt3)
              {
                num_of_iter++;
              }
            }
            else
            {
                //tiling + loop unrolling
                for (j=pu1; j<=pu2; j+=pu3)
                {
                  num_of_iter++;
                }

              //just loop unrolling
              for (j=pu1; j<=pu2; j+=pu3)
              {
                num_of_iter++;
              }
            }
          }
        }
      }
    }
    else if (str_strat.equals("1c") ||
             str_strat.equals("2c"))
    {
      int nac=ctr.GetNumArraysComm();

      if (nac!=0)
      {
          //common array padding
          for (j=pp1; j<=pp2; j+=pp3)
          {
            num_of_iter++;
          }
      }

      int np=ctr.GetNumProcs();

      //non-common array transformations
      for (p=0; p<np; p++)
      {
        //Array transformations
        int na=ctr.GetNumArrays(p);

        if (na==0)
        {
        }
        else 
        {
            for (j=pp1; j<=pp2; j+=pp3)
            {
              num_of_iter++;
            }
        }
      }

      //loop transformations
      for (p=0; p<np; p++)
      {
        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
              //loop tiling
              for (j=pt1; j<=pt2; j+=pt3)
              {
                num_of_iter++;
              }
            }
            else
            {
              //tiling + loop unrolling
              for (j=pu1; j<=pu2; j+=pu3)
              {
                num_of_iter++;
              }

              //just loop unrolling
              for (j=pu1; j<=pu2; j+=pu3)
              {
                num_of_iter++;
              }
            }
          }
        }
      }
    }
    else if (str_strat.equals("3a") ||
             str_strat.equals("4a"))
    {
      int nac=ctr.GetNumArraysComm();

      if (nac!=0)
      {
        for (i=0; i<nac; i++)
        {
          //common array padding
          for (j=pp1; j<=pp2; j+=pp3)
          {
            num_of_iter++;
          }

          //common array padding
          for (j=-pg; j<=pg; j++)
          {
            num_of_iter++;
          }
        }
      }

      int np=ctr.GetNumProcs();

      //non-common array transformations
      for (p=0; p<np; p++)
      {
        //Array transformations
        int na=ctr.GetNumArrays(p);

        if (na==0)
        {
        }
        else 
        {
          for (i=0; i<na; i++)
          {
            for (j=pp1; j<=pp2; j+=pp3)
            {
              num_of_iter++;
            }
            //non-common array padding
            for (j=-pg; j<=pg; j++)
            {
              num_of_iter++;
            }
          }
        }
      }

      //loop transformations
      for (p=0; p<np; p++)
      {
        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
              //loop tiling
              for (j=pt1; j<=pt2; j+=pt3)
              {
                num_of_iter++;
              }

              //loop tiling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              }
            }
            else
            {
              for (j=pu1; j<=pu2; j+=pu3)
              {
                num_of_iter++;
              }

              //loop unrolling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              }

              //just loop unrolling
              for (j=pu1; j<=pu2; j+=pu3)
              {
                num_of_iter++;
              }

              //loop unrolling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              }
            }
          }
        }
      }
    }
    else if (str_strat.equals("3c") ||
             str_strat.equals("4c"))
    {
      int nac=ctr.GetNumArraysComm();

      if (nac!=0)
      {
          //common array padding
          for (j=pp1; j<=pp2; j+=pp3)
          {
            num_of_iter++;
          }

          //common array padding
          for (j=-pg; j<=pg; j++)
          {
            num_of_iter++;
          }
      }

      int np=ctr.GetNumProcs();

      //non-common array transformations
      for (p=0; p<np; p++)
      {
        //Array transformations
        int na=ctr.GetNumArrays(p);

        if (na==0)
        {
        }
        else 
        {
            for (j=pp1; j<=pp2; j+=pp3)
            {
              num_of_iter++;
            }
            //non-common array padding
            for (j=-pg; j<=pg; j++)
            {
              num_of_iter++;
            }
        }
      }

      //loop transformations
      for (p=0; p<np; p++)
      {
        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
              //loop tiling
              for (j=pt1; j<=pt2; j+=pt3)
              {
                num_of_iter++;
              }

              //loop tiling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              }
            }
            else
            {
              for (j=pu1; j<=pu2; j+=pu3)
              {
                num_of_iter++;
              }

              //loop unrolling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              }

              //just loop unrolling
              for (j=pu1; j<=pu2; j+=pu3)
              {
                num_of_iter++;
              }

              //loop unrolling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              }
            }
          }
        }
      }
    }
    else if (str_strat.equals("5a") ||
             str_strat.equals("6a"))
    {
      int nac=ctr.GetNumArraysComm();

      if (nac!=0)
      {
        for (i=0; i<nac; i++)
        {
          //common array padding
          for (j=1; j<=pr; j++)
          {
            num_of_iter++;
          }
        }
      }

      int np=ctr.GetNumProcs();

      //non-common array transformations
      for (p=0; p<np; p++)
      {
        //Array transformations
        int na=ctr.GetNumArrays(p);

        if (na==0)
        {
        }
        else 
        {
          for (i=0; i<na; i++)
          {
            for (j=1; j<=pr; j++)
            {
              num_of_iter++;
            }
          }
        }
      }

      //loop transformations
      for (p=0; p<np; p++)
      {
        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
              //loop tiling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }
            }
            else
            {
              //loop unrolling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }

              //just loop unrolling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }
            }
          }
        }
      }
    }
    else if (str_strat.equals("5c") ||
             str_strat.equals("6c"))
    {
      int nac=ctr.GetNumArraysComm();

      if (nac!=0)
      {
          //common array padding
          for (j=1; j<=pr; j++)
          {
            num_of_iter++;
          }
      }

      int np=ctr.GetNumProcs();

      //non-common array transformations
      for (p=0; p<np; p++)
      {
        //Array transformations
        int na=ctr.GetNumArrays(p);

        if (na==0)
        {
        }
        else 
        {
            for (j=1; j<=pr; j++)
            {
              num_of_iter++;
            }
        }
      }

      //loop transformations
      for (p=0; p<np; p++)
      {
        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
              //loop tiling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }
            }
            else
            {
              //loop unrolling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }

              //just loop unrolling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }
            }
          }
        }
      }
    }
    else if (str_strat.equals("7a") ||
             str_strat.equals("8a"))
    {
      int nac=ctr.GetNumArraysComm();

      if (nac!=0)
      {
        for (i=0; i<nac; i++)
        {
          //common array padding
          for (j=1; j<=pr; j++)
          {
            num_of_iter++;
          }

          //common array padding
          for (j=-pg; j<=pg; j++)
          {
            num_of_iter++;
          }
        }
      }

      int np=ctr.GetNumProcs();

      //non-common array transformations
      for (p=0; p<np; p++)
      {
        //Array transformations
        int na=ctr.GetNumArrays(p);

        if (na==0)
        {
        }
        else 
        {
          for (i=0; i<na; i++)
          {
            for (j=1; j<=pr; j++)
            {
              num_of_iter++;
            }

            //non-common array padding
            for (j=-pg; j<=pg; j++)
            {
              num_of_iter++;
            }
          }
        }
      }

      //loop transformations
      for (p=0; p<np; p++)
      {
        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
              //loop tiling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }

              //loop tiling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              }
            }
            else
            {
              //loop unrolling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }

              //loop unrolling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              }

              //just loop unrolling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }

              //loop unrolling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              } 
            }
          }
        }
      }
    }
    else if (str_strat.equals("7c") ||
             str_strat.equals("8c"))
    {
      int nac=ctr.GetNumArraysComm();

      if (nac!=0)
      {
          //common array padding
          for (j=1; j<=pr; j++)
          {
            num_of_iter++;
          }

          //common array padding
          for (j=-pg; j<=pg; j++)
          {
            num_of_iter++;
          }
      }

      int np=ctr.GetNumProcs();

      //non-common array transformations
      for (p=0; p<np; p++)
      {
        //Array transformations
        int na=ctr.GetNumArrays(p);

        if (na==0)
        {
        }
        else 
        {
            for (j=1; j<=pr; j++)
            {
              num_of_iter++;
            }

            //non-common array padding
            for (j=-pg; j<=pg; j++)
            {
              num_of_iter++;
            }
        }
      }

      //loop transformations
      for (p=0; p<np; p++)
      {
        int nl=ctr.GetNumLoops(p);

        if (nl!=0)
        {
          for (i=0; i<nl; i++)
          {
            if (!ctr.GetParamL(p, i).equals("0"))
            {
              //loop tiling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }

              //loop tiling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              }
            }
            else
            {
              //loop unrolling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }

              //loop unrolling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              }

              //just loop unrolling
              for (j=1; j<=pr; j++)
              {
                num_of_iter++;
              }

              //loop unrolling
              for (j=-pg; j<=pg; j++)
              {
                num_of_iter++;
              } 
            }
          }
        }
      }
    }
    else
    {
      try
      {
        fout.write("Error: Unknown strategy!");
        fout.newLine();
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }
    }

    int np=ctr.GetNumProcs();
    int nac=ctr.GetNumArraysComm();

    int na1=0;
    int nl1=0;

    for (p=0; p<np; p++)
    {
      //Array transformations
      na1+=ctr.GetNumArrays(p);
      nl1+=ctr.GetNumLoops(p);
    }

    try
    {
      fout.write("*****************************************************************************");
      fout.newLine();

      fout.write("Number of choosen procedures:        "+String.valueOf(np));
      fout.newLine();
      fout.write("Number of choosen common arrays:     "+String.valueOf(nac));
      fout.newLine();
      fout.write("Number of choosen non-common arrays: "+String.valueOf(na1));
      fout.newLine();
      fout.write("Number of choosen loops:             "+String.valueOf(nl1));
      fout.newLine();

      fout.newLine();
      fout.write("Approximate number of iterations:    "+String.valueOf(num_of_iter));
      fout.newLine();
      fout.write("*****************************************************************************");
      fout.newLine();
      fout.flush();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    out.println("Ok");
    out.flush();
  }

  //**************************************************************************
  void Go6(PrintWriter out,
           CGlobal g,
           BufferedWriter fout,
           String str_dir,
           String str_fp,
           String str_ft)
  {
    int ind1=0;
    int ind2=0;

    int i=0;
    int j=0;

    BufferedReader fin=null;

    String str="";
    String x1="";
    String x2="";
    String x3="";
    String str1=str_dir+str_fp;

    //Dealing with project
    CProject cp = new CProject();

    if (cp.Init(g.lng, str1, 4096)!=0)
    {
      out.println("Error (internal): Can't initialize object CProject!");
      out.flush();
      return;
    }

    if (cp.Parse()<0)
    {
      out.println(cp.GetLastError());
      out.flush();
      return;
    }
    if (cp.ParseLng()<0)
    {
      out.println(cp.GetLastError());
      out.flush();
      return;
    }

    //Dealing with tree
    String str2=str_dir+str_ft+"2";

    CTree ctr = new CTree();

    if (ctr.Init(str2, 4096)!=0)
    {
      out.println("Error (internal): Can't initialize object CTree!");
      out.flush();
      return;
    }

    if (ctr.Parse()<0)
    {
      out.println(ctr.GetLastError());
      out.flush();
      return;
    }

    try
    {
      fout.write("*****************************************************************************");
      fout.newLine();

      fout.flush();
      
      if (ctr.GetNumProcs()==0)
      {
        fout.write("Error: No selected arrays or loops in tree file!");
        fout.newLine();
      }
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    String sa1="p01";
    String sa2="p02";
    String sa3="p03";

    String sp1=str_fp+"_"+sa1+"_";
    String sp2=str_fp+"_"+sa2+"_";
    String sp3=str_fp+"_"+sa3+"_";

    String sp1x="_eos_s_pred_tmp_"+sa1+"_";
    String sp2x="_eos_s_pred_tmp_"+sa2+"_";
    String sp3x="_eos_s_pred_tmp_"+sa3+"_";

    String[] flx=new String[8192];
    int iflx=0;

    //Reading tree (step1)
    try
    {
      fin=new BufferedReader(new FileReader(str2));
    }
    catch (IOException e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    try
    {
      while ((str=fin.readLine())!=null)
      {
        boolean incorrect=true;

        ind1=str.indexOf("'");
        ind2=str.indexOf("'", ind1+1);

        if ((ind1!=-1) && (ind2!=-1))
        {
          String str1a=str.substring(ind1+1, ind2);

          ind1=str.indexOf("'", ind2+1);
          ind2=str.indexOf("'", ind1+1);

          if ((ind1!=-1) && (ind2!=-1))
          {
            String str1b=str1.substring(ind1+1, ind2);

            ind1=str.indexOf("'", ind2+1);
            ind2=str.indexOf("'", ind1+1);

            if ((ind1!=-1) && (ind2!=-1))
            {
              String str1c=str.substring(ind1+1, ind2);

              str1c=str1c.toLowerCase();

              incorrect=false;

              if (str1c.equals("loop"))
              {
                if (str.charAt(0)=='+')
                {
                  flx[iflx]=str1a;
                  iflx++;
                }
              }
            }
          }
        }

        if (incorrect)
        {
          out.println("Error: Can't understand format of the tree file!");
          out.flush();
          return;
        }
      }
    }
    catch (Exception e1)
    {
      try
      {
        fin.close();
      }
      catch (Exception e2)
      {}
      out.println("Error: Problems while reading tree file!");
      out.flush();
      return;
    }

    try
    {
      fin.close();
    }
    catch (Exception e3)
    {}

    //copying files
    for (i=0; i<iflx; i++)
    {
      str=flx[i];
      ind1=str.lastIndexOf(".");
      
      CMisc.CopyTextFile(str_dir+flx[i], 
                         str_dir+flx[i].substring(0,ind1)+"_"+sa1+
                                 flx[i].substring(ind1,flx[i].length()));
      CMisc.CopyTextFile(str_dir+flx[i], 
                         str_dir+flx[i].substring(0,ind1)+"_"+sa2+
                                 flx[i].substring(ind1,flx[i].length()));
      CMisc.CopyTextFile(str_dir+flx[i], 
                         str_dir+flx[i].substring(0,ind1)+"_"+sa3+
                                 flx[i].substring(ind1,flx[i].length()));
    }

    //creating final projects
    CProject cp_new1 = new CProject();
    cp_new1.Init(cp, str_dir+sp1);

    CProject cp_new1x = new CProject();
    cp_new1x.Init(cp, str_dir+sp1x);

    CProject cp_new2 = new CProject();
    cp_new2.Init(cp, str_dir+sp2);

    CProject cp_new2x = new CProject();
    cp_new2x.Init(cp, str_dir+sp2x);

    CProject cp_new3 = new CProject();
    cp_new3.Init(cp, str_dir+sp3);

    CProject cp_new3x = new CProject();
    cp_new3x.Init(cp, str_dir+sp3x);

    for (j=1; j<cp.GetNumFiles(); j++)
    {
      boolean found=false;

      for (i=0; i<iflx; i++)
      {
        if (flx[i].equals(cp.GetFileName(j)+cp.GetFileExt(j)))
        {
          found=true;
          break;
        }
      }

      if (found)
      {
        cp_new1.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j)+"_"+sa1+"_tmp",
                         cp.GetFileExt(j), cp.GetExtraOpt(j));
        cp_new2.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j)+"_"+sa2+"_tmp",
                         cp.GetFileExt(j), cp.GetExtraOpt(j));
        cp_new3.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j)+"_"+sa3+"_tmp",
                         cp.GetFileExt(j), cp.GetExtraOpt(j));

        cp_new1x.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j)+"_"+sa1,
                          cp.GetFileExt(j), cp.GetExtraOpt(j));
        cp_new2x.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j)+"_"+sa2,
                          cp.GetFileExt(j), cp.GetExtraOpt(j));
        cp_new3x.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j)+"_"+sa3,
                          cp.GetFileExt(j), cp.GetExtraOpt(j));
      }
      else
      {
        cp_new1.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j),
                         cp.GetFileExt(j), cp.GetExtraOpt(j));
        cp_new2.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j),
                         cp.GetFileExt(j), cp.GetExtraOpt(j));
        cp_new3.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j),
                         cp.GetFileExt(j), cp.GetExtraOpt(j));

        cp_new1x.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j),
                          cp.GetFileExt(j), cp.GetExtraOpt(j));
        cp_new2x.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j),
                          cp.GetFileExt(j), cp.GetExtraOpt(j));
        cp_new3x.AddLine1(cp.GetLngNameOrig(j), cp.GetFileName(j),
                          cp.GetFileExt(j), cp.GetExtraOpt(j));
      }
    }

    if (cp_new1.Save()<0  || cp_new2.Save()<0  || cp_new3.Save()<0 ||
        cp_new1x.Save()<0 || cp_new2x.Save()<0 || cp_new3x.Save()<0)
    {
      try
      {
        fout.write("Error: Can't save new project!");
        fout.newLine();
        fout.flush();
        return;
      }
      catch (Exception e2)
      {
        out.println("Error: Problems while writing diagnostic files!");
        out.flush();
        return;
      }
    }

    //transformations
    //Create CClient for Compilation Server
    CClient cl=new CClient();
    if (cl.Init(g.cfg.GetParamStr(g.cfgCSerHost),
                g.cfg.GetParamInt(g.cfgCSerPort),
                8192)!=0)
    {
      out.println("Error (internal): Can't initialize object CClient!");
      out.flush();
      return;
    }

    //Initializing CTransformations
    CTime ct9=new CTime();

    CTransformations1 ctrans1=new CTransformations1();
    if (ctrans1.Init1(8192, ctr, cl, cp_new1x, g, str_dir)<0)
    {
      out.println(ctrans1.GetLastError());
      out.flush();
      return;
    }

    CTransformations1 ctrans2=new CTransformations1();
    if (ctrans2.Init1(8192, ctr, cl, cp_new2x, g, str_dir)<0)
    {
      out.println(ctrans1.GetLastError());
      out.flush();
      return;
    }

    CTransformations1 ctrans3=new CTransformations1();
    if (ctrans3.Init1(8192, ctr, cl, cp_new3x, g, str_dir)<0)
    {
      out.println(ctrans1.GetLastError());
      out.flush();
      return;
    }

    //transformations
    int np=ctr.GetNumProcs();

    for (int p=0; p<np; p++)
    {
      int nl=ctr.GetNumLoops(p);

      boolean tile_once=false;

      if (nl!=0)
      {
        for (i=0; i<nl; i++)
        {
          int nest=0;
          try
          {
            nest=Integer.valueOf(ctr.GetParamL(p, i)).intValue();
          }
          catch (NumberFormatException nfe1)
          {}

          if (nest!=0)
          {
            if (!tile_once)
            {
              tile_once=true;

              String fil=ctr.GetFileL(p, i);

              ind1=fil.lastIndexOf(".");
      
              ctrans1.Add1(2, 2, p, i, "4", "", true, 
                           fil.substring(0,ind1)+"_"+sa1+
                           fil.substring(ind1,fil.length()));

              ctrans3.Add1(2, 2, p, i, "4", "", true, 
                           fil.substring(0,ind1)+"_"+sa3+
                           fil.substring(ind1,fil.length()));
              ctrans3.Add1(2, 4, p, i+nest, "4", "", true, 
                           fil.substring(0,ind1)+"_"+sa3+
                           fil.substring(ind1,fil.length()));
            }
          }
          else
          {
            tile_once=false;

            String fil=ctr.GetFileL(p, i);

            ind1=fil.lastIndexOf(".");
      
            ctrans2.Add1(2, 4, p, i, "4", "", true, 
                         fil.substring(0,ind1)+"_"+sa2+
                         fil.substring(ind1,fil.length()));
          }
        }
      }
    }

    if (ctrans1.Transform1()<0 ||
        ctrans2.Transform1()<0 ||
        ctrans3.Transform1()<0)
    {
      out.println(ctrans1.GetLastError());
      out.flush();
      return;
    }

    try
    {
      fout.write("*****************************************************************************");
      fout.newLine();

      fout.flush();
    }
    catch (Exception e2)
    {
      out.println("Error: Problems while writing diagnostic files!");
      out.flush();
      return;
    }

    out.println("Ok");
    out.flush();
  }
}
